REM =================================================================
REM Boot   collecting boot trace.
REM =================================================================
REM // umstartup
REM c2ba06e2-f7ce-44aa-9e7e-62652cdefe97 => WinInitWpp        
REM d451642c-63a6-11d7-9720-00b0d03e0347 => WinlogonWpp       
REM 301779E2-227D-4FAF-AD44-664501302D03 => WlClNtfy
REM 5B4F9E61-4334-409F-B8F8-73C94A2DBA41 => UserInit
REM A789EFEB-FC8A-4C55-8301-C2D443B933C0 => UmsHlpr
REM // winlogon 
REM D9391D66-EE23-4568-B3FE-876580B31530 => StateMachine
REM 19D78D7D-476C-47B6-A484-285D1290A1F3 => SysNtfy
REM 855ED56A-6120-4564-B083-34CB9D598A22 => SetupLib
REM D138F9A7-0013-46A6-ADCC-A3CE6C46525F => WMsgSrv
REM 63665931-A4EE-47B3-874D-5155A5CFB415 => AuthzTraceProvider
REM b39b8cea-eaaa-5a74-5794-4948e222c663 => WinlogonTelemetry 
REM 5B4F9E61-4334-409F-B8F8-73C94A2DBA41 => UserInitWpp       
REM a789efeb-fc8a-4c55-8301-c2d443b933c0 => UmsHlprWpp        
REM 8db3086d-116f-5bed-cfd5-9afda80d28ea => CPF               
REM c0ac3923-5cb1-5e37-ef8f-ce84d60f1c74 => TSSessionUX       
REM fb3cd94d-95ef-5a73-b35c-6c78451095ef => CredProvDataModel 
REM 3ec987dd-90e6-5877-ccb7-f27cdf6a976b => WinlogonRPC       
REM a6c5c84d-c025-5997-0d82-e608d1abbbee => PicturePassword   
REM 41ad72c3-469e-5fcf-cacf-e3d278856c08 => BlockedShutdown   
REM df350158-0f8f-555d-7e4f-f1151ed14299 => BioFeedback
REM C127C1A8-6CEB-11DA-8BDE-F66BAD1E3F3A => TSRdpInitTrace       
REM BFA655DC-6C51-11DA-8BDE-F66BAD1E3F3A => TSRDPShellTrace
REM // LogonUI
REM 1941DE80-2226-413B-AFA4-164FD76914C1 => Microsoft.Windows.Desktop.Shell.WindowsUIImmersive.LockScreen
REM 176cd9c5-c90c-5471-38ba-0eeb4f7e0bd0 => Microsoft.Windows.UI.Logon
REM 74cc4a0b-f577-5929-abcb-aa4bea374cb3 => Microsoft.Windows.Shell.LockAppHost
REM 74cc4a0b-f577-5929-abcb-aa4bea374cb3 => Microsoft.Windows.Shell.LockAppHost
REM f8e28969-b1df-57fa-23f6-42260c77135c => Microsoft.Windows.ImageSanitization
REM 4f7c073a-65bf-5045-7651-cc53bb272db5 => Microsoft.Windows.LogonController
REM 1915117c-a61c-54d4-6548-56cac6dbfede => Microsoft.Windows.Shell.AboveLockActivationManager
REM e58f5f9c-3abb-5fc1-5ae5-dbe956bdbd33 => Microsoft.Windows.Shell.AboveLockShellComponent
REM b2149bc3-9dfd-5866-92a7-b556b3a6aed0 => Microsoft.Windows.Shell.DefaultLockApp
REM 9ca921e3-25a4-5d34-39da-a59bd8bdf7a2 => Microsoft.Windows.Shell.LockAppBroker
REM b93d4107-dc22-5d11-c2e1-afba7a88d694 => Microsoft.Windows.Shell.Tracing.LockAppBroker
REM 96319132-2f52-5969-f14c-0d0a171b357a => Microsoft.Windows.Shell.LockFrameworkUAP
REM 4191edaf-80c5-5ae3-49aa-325bd25cab2e => Microsoft.Windows.ComposableShell.Components.LockScreenHost
REM // Folder Redirect
REM 2955e23c-4e0b-45ca-a181-6ee442ca1fc0 => Microsoft\Shell
REM // Profile
REM EB7428F5-AB1F-4322-A4CC-1F1A9B2C5E98 => Profile
REM DB00DFB6-29F9-4A9C-9B3B-1F4F9E7D9770 => Microsoft-Windows-User Profiles General
REM 89B1E9F0-5AFF-44A6-9B44-0A07A7CE5845 => Microsoft-Windows-User Profiles Service
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB (ETW traces only)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=autosession\

set tracename1=LogonUI
set tracename2=ProfileTrace
set tracename3=FrTrace
set ARC=86
echo %PROCESSOR_ARCHITECTURE% | findstr "64" > NUL
if !ERRORLEVEL! equ 0 (
   set ARC=64
)

if /i "%1" =="start" (

   logman %tracename1% -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP
   
   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   ECHO %tracelogdir% > %scriptlogdir%\boot-scriptlogdir.txt

   logman create trace "%boot%%tracename1%" -ow -o %tracelogdir%\%COMPUTERNAME%_%tracename1%_%logdate%.etl -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets

   REM //
   REM // umstartup (Winlogon / WinInit)
   REM // 
   reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Winlogon /v TracingControlLevel /t REG_DWORD /d 0xffffffff /f
   reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WinInit /v TracingControlLevel /t REG_DWORD /d 0xffffffff /f

   REM // 
   REM // Winlogon / LogonUI
   REM // 
   REM logman update trace "%boot%%tracename1%" -p {c2ba06e2-f7ce-44aa-9e7e-62652cdefe97} 0xffffffffffffffff 0xff -ets
   REM logman update trace "%boot%%tracename1%" -p {d451642c-63a6-11d7-9720-00b0d03e0347} 0xffffffffffffffff 0xff -ets
   REM logman update trace "%boot%%tracename1%" -p {301779E2-227D-4FAF-AD44-664501302D03} 0xffffffffffffffff 0xff -ets 
   REM logman update trace "%boot%%tracename1%" -p {5B4F9E61-4334-409F-B8F8-73C94A2DBA41} 0xffffffffffffffff 0xff -ets 
   REM logman update trace "%boot%%tracename1%" -p {A789EFEB-FC8A-4C55-8301-C2D443B933C0} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {D9391D66-EE23-4568-B3FE-876580B31530} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {19D78D7D-476C-47B6-A484-285D1290A1F3} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {855ED56A-6120-4564-B083-34CB9D598A22} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {D138F9A7-0013-46A6-ADCC-A3CE6C46525F} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {63665931-A4EE-47B3-874D-5155A5CFB415} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {b39b8cea-eaaa-5a74-5794-4948e222c663} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {dbe9b383-7cf3-4331-91cc-a3cb16a3b538} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {5B4F9E61-4334-409F-B8F8-73C94A2DBA41} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {a789efeb-fc8a-4c55-8301-c2d443b933c0} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {8db3086d-116f-5bed-cfd5-9afda80d28ea} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {c0ac3923-5cb1-5e37-ef8f-ce84d60f1c74} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {fb3cd94d-95ef-5a73-b35c-6c78451095ef} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {3ec987dd-90e6-5877-ccb7-f27cdf6a976b} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {a6c5c84d-c025-5997-0d82-e608d1abbbee} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {41ad72c3-469e-5fcf-cacf-e3d278856c08} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {df350158-0f8f-555d-7e4f-f1151ed14299} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {C127C1A8-6CEB-11DA-8BDE-F66BAD1E3F3A} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename1%" -p {BFA655DC-6C51-11DA-8BDE-F66BAD1E3F3A} 0xffffffffffffffff 0xff -ets

   logman update trace "%boot%%tracename1%" -p {1941DE80-2226-413B-AFA4-164FD76914C1} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {176cd9c5-c90c-5471-38ba-0eeb4f7e0bd0} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {74cc4a0b-f577-5929-abcb-aa4bea374cb3} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {f8e28969-b1df-57fa-23f6-42260c77135c} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {4f7c073a-65bf-5045-7651-cc53bb272db5} 0xffffffffffffffff 0xff -ets  
   logman update trace "%boot%%tracename1%" -p {1915117c-a61c-54d4-6548-56cac6dbfede} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {e58f5f9c-3abb-5fc1-5ae5-dbe956bdbd33} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {b2149bc3-9dfd-5866-92a7-b556b3a6aed0} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {9ca921e3-25a4-5d34-39da-a59bd8bdf7a2} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {b93d4107-dc22-5d11-c2e1-afba7a88d694} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {96319132-2f52-5969-f14c-0d0a171b357a} 0xffffffffffffffff 0xff -ets 
   logman update trace "%boot%%tracename1%" -p {4191edaf-80c5-5ae3-49aa-325bd25cab2e} 0xffffffffffffffff 0xff -ets 
   
   REM //
   REM // Profile
   REM // 
   logman create trace "%boot%%tracename2%" -ow -o %tracelogdir%\%COMPUTERNAME%_%tracename2%_%logdate%.etl -p {EB7428F5-AB1F-4322-A4CC-1F1A9B2C5E98} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%%tracename2%" -p {DB00DFB6-29F9-4A9C-9B3B-1F4F9E7D9770} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%%tracename2%" -p {89B1E9F0-5AFF-44A6-9B44-0A07A7CE5845} 0xffffffffffffffff 0xff -ets

   REM // 
   REM // Folder Redirect
   REM // 
   logman create trace "%boot%%tracename3%" -ow -o %tracelogdir%\%COMPUTERNAME%_%tracename3%_%logdate%.etl -p {2955e23c-4e0b-45ca-a181-6ee442ca1fc0} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets

   REM // 
   REM // Group Policy
   REM // 
   reg add "HKLM\Software\Microsoft\Windows NT\CurrentVersion\Diagnostics" /v GPSvcDebugLevel /t REG_DWORD /d 196610 /f

   REM //
   REM // SCM
   REM //
   reg add "HKLM\Software\Microsoft\Windows NT\CurrentVersion\Tracing\SCM\Regular" /t REG_DWORD /v TracingDisabled /d 0 /F

   REM //
   REM // Netlogon
   REM //
   nltest /dbflag:0x2fffffff

   REM // 
   REM // WPR boot trace 
   REM // 
   %libdir%\WPR10-x!ARC!\wpr.exe -boottrace -addboot GeneralProfile -addboot CPU -addboot FileIO -addboot DiskIO -addboot Network -filemode
   
   REM Microsoft-Windows-Services
   logman create trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -ow -o "%tracelogdir%\WPR_initiated_WprApp_boottr_WPR OnOff Collector.etl" -p {0063715b-eeda-4007-9429-ad526f62696e} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   REM Microsoft-Windows-Services-Svchost
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {06184c97-5201-480e-92af-3a3626c5b140} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Kernel-Boot
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {15ca44ff-4d7a-4baa-bba5-0998955e531e} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-ReadyBoostDriver
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {2a274310-42d5-4019-b816-e4b8c7abe95c} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Subsys-SMSS
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {43e63da5-41d1-4fbf-aded-1bbed98fdd1d} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-CodeIntegrity
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {4ee76bd8-3cf4-44a0-a0ac-3937643e37a3} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Kernel-Prefetch
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {5322d61a-9efa-4bc3-a3f9-14be95c144f8} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Shell-AuthUI
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {63d2bb1d-e39a-41b8-9a3d-52dd06677588} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Kernel-General
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {a68ca8b7-004f-d7b6-a698-07e2de0f1f5d} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-GroupPolicy
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {aea1b4fa-97d1-45f2-a64c-4d69fffd92c9} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Kernel-EventTracing
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {b675ec37-bdb6-4648-bc92-f3fdc74d3ca2} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Winlogon
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {dbe9b383-7cf3-4331-91cc-a3cb16a3b538} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-TaskScheduler
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {de7b24ea-73c8-4a09-985d-5bdadcfa9017} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-ReadyBoost
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {e6307a09-292c-497e-aad6-498f68e2b619} 0xffffffffffffffff 0xff -ets 
   REM Microsoft-Windows-Kernel-PnP
   logman update trace "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" -p {9C205A39-1250-487D-ABD7-E831C6290539} 0xffffffffffffffff 0xff -ets 
   

   if DEFINED boot (
      reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\%tracename1%" /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_%tracename1%.etl" /f
      reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\%tracename2%" /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_%tracename2%.etl" /f
      reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\%tracename3%" /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_%tracename3%.etl" /f
      reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\WPR_initiated_WprApp_boottr_WPR OnOff Collector" /v FileName /t REG_SZ /d "%tracelogdir%\WPR_initiated_WprApp_boottr_WPR OnOff Collector.etl" /f
   )
   exit /b
   
) else if /i "%1" =="stop" (
   
   REM // 
   REM // Check if data collector sets exist and stop them
   REM // 
   logman %tracename1% -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman %tracename1% -ets ^| findstr /c:"Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "%tracename1%" -ets
   )

   logman %tracename2% -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman %tracename2% -ets ^| findstr /c:"Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "%tracename2%" -ets
   )

   logman %tracename3% -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman %tracename3% -ets ^| findstr /c:"Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "%tracename3%" -ets
   )


   for /f %%a in (%scriptlogdir%\boot-scriptlogdir.txt) do (
      set tracelogdir=%%a
   )

   REM // 
   REM // Disable Winlogon
   REM // 
   reg delete "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Winlogon" /v TracingControlLevel /f
   reg delete "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WinInit" /v TracingControlLevel /f
   copy %Windir%\system32\umstartup* !tracelogdir! /Y > NUL 2>&1

   REM //
   REM // Disable Gpsvc trace
   REM // 
   reg delete "HKLM\Software\Microsoft\Windows NT\CurrentVersion\Diagnostics" /v GPSvcDebugLevel /f
   copy %windir%\debug\UserMode !tracelogdir! /Y > NUL 2>&1

   REM //
   REM // Disable SCM trace
   REM //
   reg add "HKLM\Software\Microsoft\Windows NT\CurrentVersion\Tracing\SCM\Regular" /t REG_DWORD /v TracingDisabled /d 1 /F
   copy %systemroot%\system32\LogFiles\Scm\SCM* !tracelogdir! /Y > NUL 2>&1

   REM //
   REM // Disable Netlogon trace
   REM //
   nltest /dbflag:0x0
   copy %systemroot%\debug\netlogon* !tracelogdir! /Y > NUL 2>&1
   
   REM // 
   REM // Stop Wpr boottrace 
   REM // 
   %libdir%\WPR10-x!ARC!\wpr -boottrace -stopboot !tracelogdir!\%COMPUTERNAME%_boot-perf_%logdate%.etl
   logman stop "WPR_initiated_WprApp_boottr_WPR OnOff Collector" -ets

   REM // 
   REM // Delete data collector set
   REM // 
   if DEFINED boot (
      logman delete "%boot%%tracename1%"
      logman delete "%boot%%tracename2%"
      logman delete "%boot%%tracename3%"   
      logman delete "%boot%WPR_initiated_WprApp_boottr_WPR OnOff Collector" 
   )

   REM //
   REM // Merge etl files and delete original files
   REM // 
   %libdir%\WPR10-x!ARC!\xperf -merge "!tracelogdir!\%COMPUTERNAME%_boot-perf_%logdate%.etl" "!tracelogdir!\WPR_initiated_WprApp_boottr_WPR OnOff Collector.etl" "!tracelogdir!\%COMPUTERNAME%_boot-perfmerged_%logdate%.etl"
   if !ERRORLEVEL! EQU 0 (
      del "!tracelogdir!\%COMPUTERNAME%_boot-perf_%logdate%.etl" /f 
      del "!tracelogdir!\WPR_initiated_WprApp_boottr_WPR OnOff Collector.etl" /f 
   )
   
   echo Tracing has been stopped.
   exit /b

) else (
   goto USAGE
)

:DEP
   ECHO %tracename1% has already been started.
exit /b

:USAGE
   ECHO   BootTrace   collecting boot trace. 
   ECHO   shacollector.bat perf boot start [output folder (default c:\mslog)]
   ECHO   shacollector.bat perf boot stop
exit /b