REM =================================================================
REM cpu       collectiong CPU performance log with Xperf .
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set ARC=86
echo %PROCESSOR_ARCHITECTURE% | findstr "64" > NUL
if !ERRORLEVEL! equ 0 (
   set ARC=64
)

if /i "%1" =="start" (
   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   ECHO %tracelogdir% > %scriptlogdir%\cpu-perf-scriptlogdir.txt
   %libdir%\WPR10-x!ARC!\xperf -on Latency+Power -stackWalk Profile -BufferSize 1024 -MaxBuffers 1024 -MaxFile %maxsize% -FileMode Circular -f %tracelogdir%\kernel.etl
   exit /b
) else if /i "%1" =="stop" (
   for /f %%a in (%scriptlogdir%\cpu-perf-scriptlogdir.txt) do (
      set tracelogdir=%%a
   )
   %libdir%\WPR10-x!ARC!\xperf -stop -d !tracelogdir!\%COMPUTERNAME%_cpu-perf_%logdate%.etl
   del !tracelogdir!\kernel.etl
   del %scriptlogdir%\cpu-perf-scriptlogdir.txt
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:USAGE
   ECHO   cpu       collectiong CPU performance log with Xperf.
   ECHO   shacollector.bat perf cpu start size [Maximum log file size in MB (default 8192 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat perf cpu stop
exit /b