REM =================================================================
REM disk       collectiong Disk performance log with Xperf.
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB

SETLOCAL ENABLEDELAYEDEXPANSION
set tracelogdir=%2
set maxsize=%3
set ARC=86
echo %PROCESSOR_ARCHITECTURE% | findstr "64" > NUL
if !ERRORLEVEL! equ 0 (
   set ARC=64
)

if /i "%1" =="start" (
   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   ECHO %tracelogdir% > %scriptlogdir%\disk-perf-scriptlogdir.txt
   %libdir%\WPR10-x!ARC!\xperf -on Latency+DISPATCHER+DISK_IO_INIT+FileIO+DRIVERS+REGISTRY -stackWalk CSwitch+ReadyThread+ThreadCreate+Profile+DiskReadInit+DiskWriteInit+DiskFlushInit+FileRead+FileWrite+FileCreate+FileDelete -BufferSize 1024 -MaxBuffers 1024 -MaxFile %maxsize% -FileMode Circular -f %tracelogdir%\kernel.etl
   exit /b
) else if /i "%1" =="stop" (
   for /f %%a in (%scriptlogdir%\disk-perf-scriptlogdir.txt) do (
      set tracelogdir=%%a
   )

   %libdir%\WPR10-x!ARC!\xperf -stop -d !tracelogdir!\%COMPUTERNAME%_disk-perf_%logdate%.etl
   del !tracelogdir!\kernel.etl
   del %scriptlogdir%\disk-perf-scriptlogdir.txt
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:USAGE
   ECHO   disk       collectiong Disk performance log with Xperf.
   ECHO   shacollector.bat perf disk start size [Maximum log file size in MB (default 8192 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat perf disk stop
exit /b