@echo off
REM =================================================================
REM heap       collectiong Heap performance log with rdrleakdiag.
REM =================================================================
REM arg1 = pid.
REM arg2 = enable or snap.
REM arg3 = output dir.

SETLOCAL ENABLEDELAYEDEXPANSION
set pid=%1
set enable_or_snap=%2
set tracelogdir=%3
set exepath=C:\Windows\System32
set build=

REM Check PID
tasklist /fi "PID eq %pid%" | findstr %pid% > nul 2>&1
if !errorlevel! equ 1 (
   echo ERROR: PID %pid% is NOT exist.
   goto USAGE
)

REM Check OS Version
ver | findstr "7601 9200 9600" > NUL
if %errorlevel% equ 0 (
   for /f "usebackq delims=" %%i in (`ver`) do set build=%%i
   set exepath=%libdir%\rdrleakdiag\!build:~-5,4!
)

REM rdrleakdiag run
if /i "%enable_or_snap%" == "enable" (
   %exepath%\rdrleakdiag.exe -p %pid% -enable
   echo rdrleakdiag has enabled PID %pid%.
   exit /b
) else if /i "%enable_or_snap%" == "snap" (
   %exepath%\rdrleakdiag.exe -p %pid% -snap
   for /D %%D in (%temp%\RDR*.tmp) do (
      set folder=%%D
      xcopy /i !folder! %tracelogdir%\!folder:~-11! > NUL
      if !errorlevel! equ 0 (
         rd !folder! /s /q
      )
   )
   echo PID %pid% was snapped by rdrleakdiag.   
   exit /b
) else (
   goto USAGE
)

:USAGE
   ECHO   shacollector.bat perf heap start pid "Process ID (ex. 1234)" enable
   ECHO   shacollector.bat perf heap start [output folder (default c:\mslog)] pid "Process ID (ex. 1234)" snap

exit /b
