REM =================================================================
REM memory       collectiong Memory performance log with Xperf.
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = POOL TAG.

SETLOCAL ENABLEDELAYEDEXPANSION
set tracelogdir=%2
set maxsize=%3
set TAG=%4
set ARC=86
echo %PROCESSOR_ARCHITECTURE% | findstr "64" > NUL
if !ERRORLEVEL! equ 0 (
   set ARC=64
) 

if /i "%1" =="start" (
   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   ECHO %tracelogdir% > %scriptlogdir%\memory-perf-scriptlogdir.txt
   if NOT "!TAG!" == "" (
      ECHO POOL TAG is !TAG!.
      %libdir%\WPR10-x!ARC!\xperf -on Base+CSwitch+POOL -stackwalk PoolAlloc+PoolAllocSession+PoolFree+PoolFreeSession -PoolTag !TAG! -BufferSize 1024 -MaxBuffers 1024 -MaxFile %maxsize% -FileMode Circular -f %tracelogdir%\kernel.etl
   ) else (
      %libdir%\WPR10-x!ARC!\xperf -on Base+CSwitch+POOL -stackwalk Profile+PoolAlloc+PoolAllocSession+PoolFree+PoolFreeSession -BufferSize 1024 -MaxBuffers 1024 -MaxFile %maxsize% -FileMode Circular -f %tracelogdir%\kernel.etl
   )
   exit /b
) else if /i "%1" =="stop" (
   for /f %%a in (%scriptlogdir%\memory-perf-scriptlogdir.txt) do (
      set tracelogdir=%%a
   )

   %libdir%\WPR10-x!ARC!\xperf -stop -d !tracelogdir!\%COMPUTERNAME%_memory-perf_%logdate%.etl
   del !tracelogdir!\kernel.etl
   del %scriptlogdir%\memory-perf-scriptlogdir.txt
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:USAGE
   ECHO   memory       collectiong Memory performance log with Xperf.
   ECHO   shacollector.bat perf memory start size [Maximum log file size in MB (default 8192 MB)] [output folder (default c:\mslog)] tag "POOL TAG (ex. FMfn)"
   ECHO   shacollector.bat perf memory stop
exit /b