REM =================================================================
REM perfmon    collecting Performance Monotor log.
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir
REM arg3 = interval
SETLOCAL ENABLEDELAYEDEXPANSION
set tracelogdir=%2
set sample-interval=%3
set retention-days=%4

if /i "%1" =="start" (
   ECHO Log folder is %tracelogdir%
   ECHO Sample interval is %sample-interval%
   ECHO Retention days is %retention-days%
   logman shacollector_perfmon > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   logman create counter shacollector_perfmon -cf %scriptdir%\perfmon-config.txt -si %sample-interval% -o %tracelogdir%\%COMPUTERNAME%_perfmon_%logdate%.blg -cnf 24:00:00 -v NNNNNN
   logman start shacollector_perfmon
   schtasks /create /tn \Microsoft\Windows\PLA\AutoDeletePerfLogs /sc DAILY /st 01:00 /NP /tr "forfiles /p %tracelogdir% /d -%retention-days% /c \"cmd /c del @file\"" /ru system /rl highest
   schtasks /create /tn \Microsoft\Windows\PLA\PerfLogOnStart /sc onstart /tr "logman start shacollector_perfmon" /ru system
   exit /b
) else if /i "%1" =="stop" (
   logman shacollector_perfmon > NUL 2>&1
   if NOT !ERRORLEVEL! EQU 0 goto NOE

   logman stop shacollector_perfmon 
   logman delete shacollector_perfmon
   schtasks /delete /tn \Microsoft\Windows\PLA\AutoDeletePerfLogs /F
   schtasks /delete /tn \Microsoft\Windows\PLA\PerfLogOnStart /F
   echo perfmon has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO perfmon (shacollector_perfmon) has already been started. please check 'logman shacollector_perfmon' command.
exit /b

:NOE
   ECHO perfmon (shacollector_perfmon) has already been stopped. please check 'logman shacollector_perfmon' command.
exit /b

:USAGE
   ECHO   perfmon    collecting Performance Monitor log.
   ECHO   shacollector.bat perfmon start [output folder (default c:\mslog)]
   ECHO   shacollector.bat perfmon start [output folder (default c:\mslog)] interval [sample interval [hh:mm:ss] (ex. 00:00:15) default 15sec]
   ECHO   shacollector.bat perfmon stop
exit /b
