REM =================================================================
REM support FSI collecting File System Information logs.
REM =================================================================
REM arg1 = output directory.
echo start collecting File System Information logs.
set supportlogdir=%~f1

set ARC=
echo %PROCESSOR_ARCHITECTURE% | findstr "64" > NUL
if %ERRORLEVEL% equ 0 (
   set ARC=64
)

set /p drive="Set drive name with one word, and push Enter key (C:\ > c) > "

if NOT EXIST "%drive%:" (
   echo ERROR: "%drive%" drive is NOT exist.
   goto ERROR
)

md %supportlogdir%

REM NFI Command
set /p prompt=Start NFI info ... <NUL
%libdir%\nfi.exe %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_nfi.txt 2>&1
echo done.

REM NTFSI Command
set /p prompt=Start NTFSI info ... <NUL
%libdir%\NTFSI\NTFSI%ARC%.exe -disk \\.\%drive%: -dir > %supportlogdir%\%COMPUTERNAME%_%drive%_NTFSI-DIR.txt 2>&1
%libdir%\NTFSI\NTFSI%ARC%.exe -disk \\.\%drive%: -file 9 > %supportlogdir%\%COMPUTERNAME%_%drive%_NTFSI-file_9.txt 2>&1
%libdir%\NTFSI\NTFSI%ARC%.exe -disk \\.\%drive%: -attr 9 20 "" > %supportlogdir%\%COMPUTERNAME%_%drive%_NTFSI-attr_9_20.txt 2>&1

for /f "usebackq tokens=2" %%i in (`findstr "$Secure" %supportlogdir%\%COMPUTERNAME%_%drive%_NTFSI-DIR.txt`) do (
%libdir%\NTFSI\NTFSI%ARC%.exe -disk \\.\%drive%: -file %%i > %supportlogdir%\%COMPUTERNAME%_%drive%_NTFSI-Secure.txt 2>&1
)

echo done.

REM Fsutil Command (Windows10 or Windows Server 2016 later support)
set /p prompt=Start FSUTIL  info ... <NUL
fsutil file queryoptimizemetadata %drive%:\$secure:$SDS > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_queryoptimizemetadata.txt 2>&1
fsutil usn queryjournal %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_queryjournal.txt 2>&1
fsutil fsinfo ntfsinfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_ntfsinfo.txt 2>&1
fsutil fsInfo sectorInfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_sectorInfo.txt 2>&1
fsutil fsInfo volumeInfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_volumeInfo.txt 2>&1
fsutil volume allocationReport %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_allocationReport.txt 2>&1
fsutil volume diskfree %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_diskfree.txt 2>&1
fsutil volume thinProvisioningInfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_thinProvisioningInfo.txt 2>&1
echo done.

echo File System Information log files are saved successfuly at %supportlogdir%

:ERROR
exit /b
