REM =================================================================
REM support cluster  collecting cluster information logs.
REM =================================================================
REM arg1 = output directory.
echo start collecting support cluster information.
set supportlogdir=%~f1

if EXIST C:\Windows\Cluster\clussvc.exe (
set /p prompt=Start Failover Cluster info ... <NUL
md %supportlogdir% > NUL 2>&1
Powershell "Get-Item c:\Windows\cluster\* | fl VersionInfo" > %supportlogdir%\%COMPUTERNAME%_clustermoduleinfo.log 2>&1
%libdir%\Checksym%PROCESSOR_ARCHITECTURE%.exe -F c:\Windows\cluster -R > %supportlogdir%\%COMPUTERNAME%_clustermoduleChecksym.log 2>&1
REG EXPORT HKLM\Cluster %supportlogdir%\%COMPUTERNAME%_Cluster.reg > NUL 2>&1
REG SAVE HKLM\Cluster %supportlogdir%\%COMPUTERNAME%_Cluster.hiv > NUL 2>&1
powershell "Get-Cluster | select *" > %supportlogdir%\%COMPUTERNAME%_get-cluster.txt 2>&1
powershell "Get-Cluster | Get-ClusterParameter" > %supportlogdir%\%COMPUTERNAME%_get-cluster-parameter.txt 2>&1
powershell "Get-Cluster | Get-ClusterParameter | select *" > %supportlogdir%\%COMPUTERNAME%_get-cluster-parameter-all.txt 2>&1
powershell Get-ClusterNode > %supportlogdir%\%COMPUTERNAME%_get-clusternode.txt 2>&1
powershell Get-ClusterGroup > %supportlogdir%\%COMPUTERNAME%_get-clustergroup.txt 2>&1
powershell Get-ClusterSharedVolumeState > %supportlogdir%\%COMPUTERNAME%_get-clustersharedvolumestate.txt 2>&1
powershell "Get-ClusterGroup | select *" > %supportlogdir%\%COMPUTERNAME%_get-clustergroup-all.txt 2>&1
powershell Get-ClusterResource > %supportlogdir%\%COMPUTERNAME%_get-clusterresource.txt 2>&1
powershell "Get-ClusterResource | select *" > %supportlogdir%\%COMPUTERNAME%_get-clusterresource-all.txt 2>&1
powershell "Get-ClusterResource | Get-ClusterParameter" > %supportlogdir%\%COMPUTERNAME%_get-clusterresource-with-parameter.txt 2>&1
powershell "Get-ClusterResource | Get-ClusterParameter | select *" > %supportlogdir%\%COMPUTERNAME%_get-clusterresource-with-parameter-all.txt 2>&1
powershell "Get-SMBShare | select *" > %supportlogdir%\%COMPUTERNAME%_get-smbshare-all.txt 2>&1
powershell "Get-ClusterS2D | select *" > %supportlogdir%\%COMPUTERNAME%_get-cluster-s2d.txt 2>&1
powershell "Get-SMBShare -SmbInstance SBL | select *" > %supportlogdir%\%COMPUTERNAME%_get-smbshare-smbinstance-sbl.txt 2>&1
powershell "Get-SMBConnection -SmbInstance SBL | select *" > %supportlogdir%\%COMPUTERNAME%_get-smbconnection-smbinstance-sbl.txt 2>&1
powershell "Get-SmbServerNetworkInterface | select *" > %supportlogdir%\%COMPUTERNAME%_get-smbservernetworkinterface.txt 2>&1
powershell "Get-StorageSubSystem Cluster* | Debug-StorageSubsystem | select *" > %supportlogdir%\%COMPUTERNAME%_debug-storagesubsystem.txt 2>&1
powershell "Get-StorageSubSystem Cluster* | Get-StorageHealthReport | select *"> %supportlogdir%\%COMPUTERNAME%_get-storagehealthreport.txt 2>&1
powershell "Get-CimInstance -Namespace root\wmi -ClassName ClusBfltDeviceInformation | select *" > %supportlogdir%\%COMPUTERNAME%_clusbflt-deviceinformation.txt 2>&1
powershell "Get-CimInstance -Namespace root\wmi -ClassName ClusPortDeviceInformation | select *" > %supportlogdir%\%COMPUTERNAME%_clusport-deviceinformation.txt 2>&1
powershell Get-ClusterNetwork > %supportlogdir%\%COMPUTERNAME%_get-clusternetwork.txt 2>&1
powershell Get-ClusterNetworkInterface > %supportlogdir%\%COMPUTERNAME%_get-clusternetworkinterface.txt 2>&1
powershell "Get-ClusterNetwork | select *" > %supportlogdir%\%COMPUTERNAME%_get-clusternetwork-all.txt 2>&1
powershell Get-ClusterSharedVolume > %supportlogdir%\%COMPUTERNAME%_get-clustersharedvolume.txt 2>&1
powershell "Get-ClusterSharedVolume | select *" > %supportlogdir%\%COMPUTERNAME%_get-clustersharedvolume-all.txt 2>&1
powershell "Get-ClusterSharedVolume | select -Property Name -ExpandProperty SharedVolumeInfo" > %supportlogdir%\%COMPUTERNAME%_get-clustersharedvolume-sharedvolumeinfo.txt 2>&1
powershell "Get-ClusterSharedVolume | Get-ClusterParameter" > %supportlogdir%\%COMPUTERNAME%_get-clustersharedvolume-clusterparameter.txt 2>&1
powershell "Get-ClusterSharedVolume | Get-ClusterParameter | select *" > %supportlogdir%\%COMPUTERNAME%_get-clustersharedvolume-clusterparameter-all.txt 2>&1
powershell "Get-ClusterQuorum | fl *" > %supportlogdir%\%COMPUTERNAME%_get-clusterquorum-all.txt 2>&1
cluster /prop > %supportlogdir%\%COMPUTERNAME%_cluster-prop.log 2>&1
cluster /priv > %supportlogdir%\%COMPUTERNAME%_cluster-priv.log 2>&1
cluster group > %supportlogdir%\%COMPUTERNAME%_cluster-group.log 2>&1
cluster group /prop > %supportlogdir%\%COMPUTERNAME%_cluster-group-prop.log 2>&1
cluster group /priv > %supportlogdir%\%COMPUTERNAME%_cluster-group-priv.log 2>&1
cluster res > %supportlogdir%\%COMPUTERNAME%_cluster-res.log 2>&1
cluster res /prop > %supportlogdir%\%COMPUTERNAME%_cluster-res-prop.log 2>&1
cluster res /priv > %supportlogdir%\%COMPUTERNAME%_cluster-res-priv.log 2>&1
cluster /quorum > %supportlogdir%\%COMPUTERNAME%_cluster-quorum.log 2>&1
cluster /listnetpri > %supportlogdir%\%COMPUTERNAME%_cluster-listnetpri.log 2>&1
cluster /share > %supportlogdir%\%COMPUTERNAME%_cluster-share.log 2>&1
cluster net > %supportlogdir%\%COMPUTERNAME%_cluster-net.log 2>&1
cluster net /prop > %supportlogdir%\%COMPUTERNAME%_cluster-net-prop.log 2>&1
cluster net /priv > %supportlogdir%\%COMPUTERNAME%_cluster-net-priv.log 2>&1
cluster netint > %supportlogdir%\%COMPUTERNAME%_cluster-netint.log 2>&1
cluster netint /prop > %supportlogdir%\%COMPUTERNAME%_cluster-netint-prop.log 2>&1
cluster netint /priv > %supportlogdir%\%COMPUTERNAME%_cluster-netint-priv.log 2>&1
cluster node > %supportlogdir%\%COMPUTERNAME%_cluster-node.log 2>&1
powershell "Get-Clusterlog -Node localhost" > NUL 2>&1
powershell "Get-Clusterlog -Node localhost -Health" > NUL 2>&1
cluster log /g /node:"localhost" > NUL 2>&1
xcopy /s C:\Windows\Cluster\Reports\* %supportlogdir% > NUL 2>&1
echo done.
)