REM =================================================================
REM support drive-space   collecting drive space information logs.
REM =================================================================
REM arg1 = output directory.
echo start collecting drive space information logs.
set supportlogdir=%~f1

set ARC=
echo %PROCESSOR_ARCHITECTURE% | findstr "64" > NUL
if !ERRORLEVEL! equ 0 (
   set ARC=64
)

set /p drive="Set drive name with one word, and push Enter key (C:\ > c) > "

if NOT EXIST "%drive%:" (
   echo ERROR: "%drive%" drive is NOT exist.
   goto ERROR
)

md %supportlogdir%

REM Dir Command
set /p prompt=Start directory info ... <NUL
%libdir%\psexec\PsExec!ARC!.exe -s -i -accepteula cmd.exe /c "dir /a /r /s /c /n %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_dir-priv.txt" > NUL 2>&1
%libdir%\psexec\PsExec!ARC!.exe -s -i -accepteula cmd.exe /c "dir /a /r /s /c /t:c /n %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_dir-createdate-priv.txt" > NUL 2>&1
dir /a /r /s /c /n %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_dir.txt 2>&1
dir /a /r /s /c /t:c /n %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_dir-createdate.txt 2>&1
echo done.

REM Du Command
set /p prompt=Start disk usage info ... <NUL
%libdir%\psexec\PsExec!ARC!.exe -s -i -accepteula cmd.exe /c "%libdir%\du\du!ARC!.exe -accepteula -q %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_du-priv.txt" > NUL 2>&1
%libdir%\psexec\PsExec!ARC!.exe -s -i -accepteula cmd.exe /c "%libdir%\du\du!ARC!.exe -accepteula -q -l 1 %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_du-l1-priv.txt" > NUL 2>&1
%libdir%\psexec\PsExec!ARC!.exe -s -i -accepteula cmd.exe /c "%libdir%\du\du!ARC!.exe -accepteula -q -v %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_du-v-priv.txt" > NUL 2>&1
%libdir%\du\du!ARC!.exe -accepteula -q %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_du.txt 2>&1
%libdir%\du\du!ARC!.exe -accepteula -q -l 1 %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_du-l1.txt 2>&1
%libdir%\du\du!ARC!.exe -accepteula -q -v %drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_du-v.txt 2>&1
echo done.

REM Fsutil Command
set /p prompt=Start file system info ... <NUL
fsutil fsinfo ntfsinfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_ntfsinfo.txt 2>&1
fsutil fsinfo sectorinfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_sectorinfo.txt 2>&1
fsutil fsinfo statistics %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_statistics.txt 2>&1
fsutil quota query %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_quota.txt 2>&1
fsutil usn queryjournal %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_queryjournal.txt 2>&1
fsutil fsInfo volumeInfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_volumeInfo.txt 2>&1
fsutil volume allocationReport %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_allocationReport.txt 2>&1
fsutil volume diskfree %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_diskfree.txt 2>&1
fsutil volume thinProvisioningInfo %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_fsutil_thinProvisioningInfo.txt 2>&1
echo done.

REM Chkdsk Command
set /p prompt=Start check disk info ... <NUL
chkdsk %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_chkdsk.txt 2>&1
echo done.

REM Defrag Command
set /p prompt=Start defrag info ... <NUL
defrag /V /A %drive%: > %supportlogdir%\%COMPUTERNAME%_%drive%_defrag.txt 2>&1
echo done.

REM VSS Command
set /p prompt=Start VSS info ... <NUL
vssadmin list Shadows > %supportlogdir%\%COMPUTERNAME%_%drive%_vssadmin_list_shadows.txt 2>&1
vssadmin list ShadowStorage > %supportlogdir%\%COMPUTERNAME%_%drive%_vssadmin_list_shadowstorage.txt 2>&1
echo done.

REM Compact Command
set /p prompt=Start NTFS compression info ... <NUL
compact /s:%drive%:\ > %supportlogdir%\%COMPUTERNAME%_%drive%_compact.txt 2>&1
echo done.

REM Analyze Command
set /p prompt=Start Analyze log ... <NUL
powershell -executionpolicy unrestricted -File %libdir%\VolumeAnalyzer.ps1 %supportlogdir% 2>&1
echo done.

echo Drive information log files are saved successfuly at %supportlogdir%
ENDLOCAL
exit /b
