REM =================================================================
REM support system collecting system information logs.
REM =================================================================
REM arg1 = output directory.
echo start collecting support system information.
set supportlogdir=%~f1

set /p prompt=Collecting System Information. <NUL
md %supportlogdir% > NUL 2>&1

set ARC=
echo %PROCESSOR_ARCHITECTURE% | findstr "64" > NUL
if !ERRORLEVEL! equ 0 (
   set ARC=64
)

systeminfo > %supportlogdir%\%COMPUTERNAME%_systeminfo.txt 2>&1
powershell "Get-CimInstance Win32_Product | select *" > %supportlogdir%\%COMPUTERNAME%_Win32_Product.txt 2>&1
verifier /query > %supportlogdir%\%COMPUTERNAME%_verifier-query.txt 2>&1
verifier /querysettings > %supportlogdir%\%COMPUTERNAME%_verifier-querysettings.txt 2>&1
tasklist > %supportlogdir%\%COMPUTERNAME%_tasklist.txt 2>&1
tasklist /M > %supportlogdir%\%COMPUTERNAME%_tasklist-M.txt 2>&1
tasklist /SVC > %supportlogdir%\%COMPUTERNAME%_tasklist-SVC.txt 2>&1
Powershell "Get-Process | Format-Table -Property "Handles","NPM","PM","WS","VM","CPU","Id","ProcessName","StartTime",@{ Label = 'Running Time';Expression={(GetAgeDescription -TimeSpan (new-TimeSpan $_.StartTime))}} -AutoSize" > %supportlogdir%\%COMPUTERNAME%_get-process.txt 2>&1
powershell "Get-MpPreference | select *" > %supportlogdir%\%COMPUTERNAME%_defender_config.txt 2>&1

set /p prompt=Start gpresult ... <NUL
gpresult /H %supportlogdir%\%COMPUTERNAME%_gpresult.html > NUL 2>&1

set /p prompt=Start msinfo32 ... <NUL
msinfo32 /nfo %supportlogdir%\%COMPUTERNAME%_msinfo32.nfo > NUL 2>&1

%libdir%\Coreinfo\Coreinfo%ARC%.exe -accepteula > %supportlogdir%\%COMPUTERNAME%_coreinfo.txt 2>&1
%libdir%\Coreinfo\Coreinfo%ARC%.exe -accepteula -v > %supportlogdir%\%COMPUTERNAME%_coreinfo-v.txt 2>&1
echo done.