REM =================================================================
REM ata     collecting ATAPort drivers trace.
REM =================================================================
REM D08BD885-501E-489A-BAC6-B7D24BFE6BBF => Storage - ATAPort
REM CB587AD1-CC35-4EF1-AD93-36CC82A2D319 => Microsoft-Windows-ATAPort
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman ata_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%ata_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_ata_trace_%logdate%.etl -p {D08BD885-501E-489A-BAC6-B7D24BFE6BBF} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%ata_trace" -p {CB587AD1-CC35-4EF1-AD93-36CC82A2D319} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\ata_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_ata_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman ata_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman ata_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "ata_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%ata_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO ata_trace has already been started.
exit /b

:USAGE
   ECHO   ata       collecting ATAPort drivers trace.
   ECHO   shacollector.bat trace ata start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace ata stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace ata boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace ata delete
exit /b

