REM =================================================================
REM cdrom     collecting CD/DVD modules trace.
REM =================================================================
REM A4196372-C3C4-42D5-87BF-7EDB2E9BCC27 => Storage - CDROM
REM 9B6123DC-9AF6-4430-80D7-7D36F054FB9F => Microsoft-Windows-CDROM
REM 944A000F-5F60-4E5A-86FD-D55B84B543E9 => udfs
REM 0E85A5A5-4D5C-44B7-8BDA-5B7AB54F7E9C => IMAPI2
REM 6B1DB052-734F-4E23-AF5E-6CD8AE459F98 => Udflib tracing
REM F8036571-42D9-480A-BABB-DE7833CB059C => FileSystemImageTracing
REM FA8DE7C4-ACDE-4443-9994-C4E2359A9EDB => ClassPnP
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman cdrom_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%cdrom_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_cdrom_trace_%logdate%.etl -p {A4196372-C3C4-42D5-87BF-7EDB2E9BCC27} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%cdrom_trace" -p {9B6123DC-9AF6-4430-80D7-7D36F054FB9F} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cdrom_trace" -p {944A000F-5F60-4E5A-86FD-D55B84B543E9} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cdrom_trace" -p {0E85A5A5-4D5C-44B7-8BDA-5B7AB54F7E9C} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cdrom_trace" -p {6B1DB052-734F-4E23-AF5E-6CD8AE459F98} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cdrom_trace" -p {F8036571-42D9-480A-BABB-DE7833CB059C} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cdrom_trace" -p {FA8DE7C4-ACDE-4443-9994-C4E2359A9EDB} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\cdrom_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_cdrom_trace.etl" /f
   )
   exit /b

) else if /i "%1" =="stop" (

   logman cdrom_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman cdrom_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "cdrom_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%cdrom_trace"
   )
   echo Tracing has been stopped.
   exit /b

) else (
   goto USAGE
)

:DEP
   ECHO cdrom_trace has already been started.
exit /b

:USAGE
   ECHO   cdrom     collecting CD/DVD modules trace.
   ECHO   shacollector.bat trace cdrom start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace cdrom stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace cdrom boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace cdrom delete

exit /b