REM =================================================================
REM cluster     collection Failover Clustering trace.
REM =================================================================
REM 11B3C6B7-E06F-4191-BBB9-7099FFF55614 => FailoverClustering-Manager
REM 0461BE3C-BC15-4BAD-9A9E-51F3FADFEC75 => FailoverClustering-WMIProvider
REM FF3E7036-643F-430F-B015-2933466FF0FD => Microsoft-Windows-FailoverClustering-WMI
REM A82FDA5D-745F-409C-B0FE-18AE0678A0E0 => Microsoft-Windows-FailoverClustering-Client
REM BAF908EA-3421-4CA9-9B84-6689B8C6F85F => Microsoft-Windows-FailoverClustering
REM FEBD78F8-DDC5-484D-848C-982F1F483278 => Microsoft-Windows-FailoverClustering-Replication
REM 7E66368D-B895-45F2-811F-FB37940421A6 => netft
REM C1FCCEB3-3F19-42A9-95B9-27B550FA1FBA => Microsoft-Windows-FailoverClustering-NetFt
REM 3122168F-2432-45F0-B91C-3AF363C14999 => ClusApiTraceLogProvider
REM 9B9E93D6-5569-4179-8C8A-5201CB2B9536 => Microsoft-Windows-ClusterAwareUpdating-Management
REM 10629806-46F2-4366-9092-53025E067E8C => Microsoft-Windows-ClusterAwareUpdating
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman cluster_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%cluster_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_cluster_trace_%logdate%.etl -p {11B3C6B7-E06F-4191-BBB9-7099FFF55614} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%cluster_trace" -p {0461BE3C-BC15-4BAD-9A9E-51F3FADFEC75} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cluster_trace" -p {FF3E7036-643F-430F-B015-2933466FF0FD} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cluster_trace" -p {A82FDA5D-745F-409C-B0FE-18AE0678A0E0} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cluster_trace" -p {BAF908EA-3421-4CA9-9B84-6689B8C6F85F} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cluster_trace" -p {FEBD78F8-DDC5-484D-848C-982F1F483278} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%cluster_trace" -p {3122168F-2432-45F0-B91C-3AF363C14999} 0xffffffffffffffff 0xff -ets
   logman create trace "%boot%netft_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_netft_trace_%logdate%.etl -p {7E66368D-B895-45F2-811F-FB37940421A6} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%netft_trace" -p {C1FCCEB3-3F19-42A9-95B9-27B550FA1FBA} 0xffffffffffffffff 0xff -ets
   logman create trace "%boot%cau_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_cau_trace_%logdate%.etl -p {9B9E93D6-5569-4179-8C8A-5201CB2B9536} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%cau_trace" -p {10629806-46F2-4366-9092-53025E067E8C} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\cluster_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_cluster_trace.etl" /f
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\netft_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_netft_trace.etl" /f
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\cau_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_cau_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman cluster_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman cluster_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "cluster_trace" -ets
   
      for /f "tokens=3 usebackq delims= " %%i in (`logman netft_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "netft_trace" -ets
      
      for /f "tokens=3 usebackq delims= " %%i in (`logman cau_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "cau_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%cluster_trace"
      logman delete "%boot%netft_trace"
      logman delete "%boot%cau_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO cluster_trace has already been started.
exit /b

:USAGE
   ECHO   cluster     collection Failover Clustering trace.
   ECHO   shacollector.bat trace cluster start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace cluster stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace cluster boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace cluster delete

exit /b