REM =================================================================
REM com       collecting COM/COM+ services trace.
REM =================================================================
REM B46FA1AD-B22D-4362-B072-9F5BA07B046D => COMSVCS
REM BDA92AE8-9F11-4D49-BA1D-A4C2ABCA692E => OLE32
REM 9474A749-A98D-4F52-9F45-5B20247E4F01 => DCOMSCM
REM A0C4702B-51F7-4EA9-9C74-E39952C694B8 => COMADMIN
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (

   logman com_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%com_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_com_trace_%logdate%.etl -p {B46FA1AD-B22D-4362-B072-9F5BA07B046D} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%com_trace" -p {BDA92AE8-9F11-4D49-BA1D-A4C2ABCA692E} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%com_trace" -p {9474A749-A98D-4F52-9F45-5B20247E4F01} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%com_trace" -p {A0C4702B-51F7-4EA9-9C74-E39952C694B8} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\com_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_com_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman com_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman com_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "com_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%com_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO com_trace has already been started.
exit /b

:USAGE
   ECHO   com       collecting COM/COM+ services trace.
   ECHO   shacollector.bat trace com start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace com stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace com boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace com delete

exit /b