REM =================================================================
REM csv     collecting CSV drivers trace.
REM =================================================================
REM D82DBA12-8B70-49EE-B844-44D0885951D2 => CSVFLT
REM 4E6177A5-C0A7-4D9B-A686-56ED5435A908 => CtlGuid ### nfilter is removed.
REM 4E6177A5-C0A7-4D9B-A686-56ED5435A904 => VBus
REM B421540C-1FC8-4C24-90CC-C5166E1DE302 => CSVFLT
REM 151D3C03-E442-4C4F-AF20-BD48FF41F793 => Microsoft-Windows-FailoverClustering-CsvFlt-Diagnostic
REM 6A86AE90-4E9B-4186-B1D1-9CE0E02BCBC1 => Microsoft-Windows-FailoverClustering-CsvFs-Diagnostic
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (

   logman csv_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%csv_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_csv_trace_%logdate%.etl -p {D82DBA12-8B70-49EE-B844-44D0885951D2} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%csv_trace" -p {4E6177A5-C0A7-4D9B-A686-56ED5435A904} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%csv_trace" -p {B421540C-1FC8-4C24-90CC-C5166E1DE302} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%csv_trace" -p {151D3C03-E442-4C4F-AF20-BD48FF41F793} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%csv_trace" -p {6A86AE90-4E9B-4186-B1D1-9CE0E02BCBC1} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\csv_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_csv_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman csv_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman csv_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "csv_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%csv_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO csv_trace has already been started.
exit /b

:USAGE
   ECHO   csv     collecting CSV drivers trace.
   ECHO   shacollector.bat trace csv start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace csv stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace csv boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace csv delete

exit /b