REM =================================================================
REM dedup     collecting Dedup drivers trace. (Windows Server 2012 or later)
REM =================================================================
REM F9FE3908-44B8-48D9-9A32-5A763FF5ED79 => Microsoft-Windows-Deduplication
REM 1D5E499D-739C-45A6-A3E1-8CBE0A352BEB => Microsoft-Windows-Deduplication-Change
REM 5EBB59D1-4739-4E45-872D-B8703956D84B => Deduplication Tracing Provider
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (

   logman dedup_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%dedup_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_dedup_trace_%logdate%.etl -p {F9FE3908-44B8-48D9-9A32-5A763FF5ED79} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%dedup_trace" -p {1D5E499D-739C-45A6-A3E1-8CBE0A352BEB} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%dedup_trace" -p {5EBB59D1-4739-4E45-872D-B8703956D84B} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\dedup_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_dedup_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman dedup_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman dedup_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
   logman stop "dedup_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%dedup_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO dedup_trace has already been started.
exit /b

:USAGE
   ECHO   dedup     collecting Dedup drivers trace. (Windows Server 2012 or later)
   ECHO   shacollector.bat trace dedeup start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace dedup stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace dedup boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace dedup delete
exit /b