REM =================================================================
REM fltmgr     collecting Filter Manager trace.
REM =================================================================
REM 4F5D14A2-97BB-454B-B848-6F3CE0DF80F1 => FltMgr
REM FD66A680-C052-4375-8CC9-225F923CEF88 => FltMgrTelemetryProvider
REM F3C5E28E-63F6-49C7-A204-E48A1BC4B09D => Microsoft-Windows-FilterManager
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (

   logman fltmgr_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%fltmgr_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_fltmgr_trace_%logdate%.etl -p {4F5D14A2-97BB-454B-B848-6F3CE0DF80F1} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%fltmgr_trace" -p {FD66A680-C052-4375-8CC9-225F923CEF88} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%fltmgr_trace" -p {F3C5E28E-63F6-49C7-A204-E48A1BC4B09D} 0xffffffffffffffff 0xff -ets


   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\fltmgr_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_fltmgr_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman fltmgr_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman fltmgr_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "fltmgr_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%fltmgr_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO fltmgr_trace has already been started.
exit /b

:USAGE
   ECHO   fltmgr       collecting Filter Manager trace.
   ECHO   shacollector.bat trace fltmgr start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace fltmgr stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace fltmgr boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace fltmgr delete
exit /b

