REM =================================================================
REM iscsi   collecting iSCSI driver trace.
REM =================================================================
REM 1BABEFB4-59CB-49E5-9698-FD38AC830A91 => iSCSI
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (

   logman iscsi_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%iscsi_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_iscsi_trace_%logdate%.etl -p {1BABEFB4-59CB-49E5-9698-FD38AC830A91} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\iscsi_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_iscsi_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman iscsi_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman iscsi_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
   logman stop "iscsi_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%iscsi_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO iscsi_trace has already been started.
exit /b

:USAGE
   ECHO   iscsi   collecting iSCSI driver trace.
   ECHO   shacollector.bat trace iscsi start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace iscsi stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace iscsi boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace iscsi delete

exit /b