REM =================================================================
REM nfs     collecting NFS services trace.
REM =================================================================
REM 3c33d8b3-66fa-4427-a31b-f7dfa429d78f => NFS Server
REM fc33d8b3-66fa-4427-a31b-f7dfa429d78f => NfsSvrNfsGuid2
REM 57294EFD-C387-4e08-9144-2028E8A5CB1A => NfsSvrNlmGuid
REM CC9A5284-CC3E-4567-B3F6-3EB24E7CFEC5 => MsNfsFltGuid
REM 355c2284-61cb-47bb-8407-4be72b5577b0 => NfsRdrGuid
REM 6361F674-C2C0-4F6B-AE19-8C62F47AE3FB => NfsClientGuid
REM E18A05DC-CCE3-4093-B5AD-211E4C798A0D => PortMapGuid
REM 94B45058-6F59-4696-B6BC-B23B7768343D => RpcXdrGuid
REM DD7A21E6-A651-46D4-B7C2-66543067B869 => NDISTraceGuid
REM eb004a05-9b1a-11d4-9123-0050047759bc => NETIO
REM E53C6823-7BB8-44BB-90DC-3F86090D48A6 => Microsoft-Windows-Winsock-AFD
REM 2F07E2EE-15DB-40F1-90EF-9D7BA282188A => Microsoft-Windows-TCPIP
REM B40AEF77-892A-46F9-9109-438E399BB894 => AFD Trace
REM f3bb9731-1d9f-4b8e-a42e-203bf1a32300 => nfs4svrguid
REM C4C52165-AD74-4B70-B62F-A8D35A135E7A => NfsClientGuid
REM 6E1CBBE9-8C4B-4003-90E2-0C2D599A3EDC => Microsoft-Windows-ServicesForNFS-Portmapper
REM 3D888EE4-5A93-4633-91E7-FFF8AFD89A7B => Microsoft-Windows-ServicesForNFS-ONCRPC
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman nfs_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%nfs_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_nfs_trace_%logdate%.etl -p {3c33d8b3-66fa-4427-a31b-f7dfa429d78f} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%nfs_trace" -p {fc33d8b3-66fa-4427-a31b-f7dfa429d78f} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {57294EFD-C387-4e08-9144-2028E8A5CB1A} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {CC9A5284-CC3E-4567-B3F6-3EB24E7CFEC5} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {355c2284-61cb-47bb-8407-4be72b5577b0} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {6361F674-C2C0-4F6B-AE19-8C62F47AE3FB} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {E18A05DC-CCE3-4093-B5AD-211E4C798A0D} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {94B45058-6F59-4696-B6BC-B23B7768343D} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {f3bb9731-1d9f-4b8e-a42e-203bf1a32300} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {C4C52165-AD74-4B70-B62F-A8D35A135E7A} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {6E1CBBE9-8C4B-4003-90E2-0C2D599A3EDC} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%nfs_trace" -p {3D888EE4-5A93-4633-91E7-FFF8AFD89A7B} 0xffffffffffffffff 0xff -ets

   logman create trace "%boot%network_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_network_trace_%logdate%.etl -p {DD7A21E6-A651-46D4-B7C2-66543067B869} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%network_trace" -p {eb004a05-9b1a-11d4-9123-0050047759bc} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%network_trace" -p {E53C6823-7BB8-44BB-90DC-3F86090D48A6} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%network_trace" -p {2F07E2EE-15DB-40F1-90EF-9D7BA282188A} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%network_trace" -p {B40AEF77-892A-46F9-9109-438E399BB894} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\nfs_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_nfs_trace.etl" /f
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\network_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_network_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman nfs_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman nfs_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "nfs_trace" -ets

      for /f "tokens=3 usebackq delims= " %%i in (`logman network_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "network_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%nfs_trace"
      logman delete "%boot%network_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO nfs_trace has already been started.
exit /b

:USAGE
   ECHO   nfs     collecting NFS services trace.
   ECHO   shacollector.bat trace nfs start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace nfs stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace nfs boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace nfs delete
exit /b