REM =================================================================
REM packet    collecting Network Packet Capture. (Windows Server 2008 R2 or later)
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   if DEFINED boot (
      netsh trace start capture=yes persistent=yes maxsize=%maxsize% traceFile=%tracelogdir%\%COMPUTERNAME%_packet_capture_%logdate%.etl
   ) else (
      netsh trace start capture=yes maxsize=%maxsize% traceFile=%tracelogdir%\%COMPUTERNAME%_packet_capture_%logdate%.etl
   )
   exit /b
) else if /i "%1" =="stop" (
   netsh trace stop
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:USAGE
   ECHO   packet    collecting Network Packet Capture. (Windows Server 2008 R2 or later)
   ECHO   shacollector.bat trace packet start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace packet stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace packet boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace packet stop
exit /b