REM =================================================================
REM pnp       collecting Plug and Play drivers trace.
REM =================================================================
REM F52E9EE1-03D4-4DB3-B2D4-1CDD01C65582 => PnpInstal
REM 9C205A39-1250-487D-ABD7-E831C6290539 => Microsoft-Windows-Kernel-PnP
REM A676B545-4CFB-4306-A067-502D9A0F2220 => PlugPlay
REM 84051B98-F508-4E54-82FA-8865C697C3B1 => Microsoft-Windows-PnPMgrTriggerProvider
REM 96F4A050-7E31-453C-88BE-9634F4E02139 => Microsoft-Windows-UserPnp
REM D5EBB80C-4407-45E4-A87A-015F6AF60B41 => Microsoft-Windows-Kernel-PnPConfig
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman pnp_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%pnp_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_pnp_trace_%logdate%.etl -p {F52E9EE1-03D4-4DB3-B2D4-1CDD01C65582} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%pnp_trace" -p {9C205A39-1250-487D-ABD7-E831C6290539} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%pnp_trace" -p {A676B545-4CFB-4306-A067-502D9A0F2220} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%pnp_trace" -p {84051B98-F508-4E54-82FA-8865C697C3B1} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%pnp_trace" -p {96F4A050-7E31-453C-88BE-9634F4E02139} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%pnp_trace" -p {D5EBB80C-4407-45E4-A87A-015F6AF60B41} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\pnp_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_pnp_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman pnp_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman pnp_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "pnp_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%pnp_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)
:DEP
   ECHO pnp_trace has already been started.
exit /b

: USAGE
   ECHO   pnp       collecting Plug and Play drivers trace.
   ECHO   shacollector.bat trace pnp start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace pnp stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace pnp boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace pnp delete
exit /b