REM =================================================================
REM rpc     collecting RPC services trace.
REM =================================================================
REM 272A979B-34B5-48EC-94F5-7225A59C85A0 => Microsoft-Windows-RPC-Proxy-LBS
REM 879B2576-39D1-4C0F-80A4-CC086E02548C => Microsoft-Windows-RPC-Proxy
REM 536CAA1F-798D-4CDB-A987-05F79A9F457E => Microsoft-Windows-RPC-LBS
REM 6AD52B32-D609-4BE9-AE07-CE8DAE937E39 => Microsoft-Windows-RPC 
REM F4AED7C7-A898-4627-B053-44A7CAA12FCD => Microsoft-Windows-RPC-Events
REM D8975F88-7DDB-4ED0-91BF-3ADF48C48E0C => Microsoft-Windows-RPCSS
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (

   logman rpc_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%rpc_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_rpc_trace_%logdate%.etl -p {272A979B-34B5-48EC-94F5-7225A59C85A0} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%rpc_trace" -p {879B2576-39D1-4C0F-80A4-CC086E02548C} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%rpc_trace" -p {536CAA1F-798D-4CDB-A987-05F79A9F457E} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%rpc_trace" -p {6AD52B32-D609-4BE9-AE07-CE8DAE937E39} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%rpc_trace" -p {F4AED7C7-A898-4627-B053-44A7CAA12FCD} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%rpc_trace" -p {D8975F88-7DDB-4ED0-91BF-3ADF48C48E0C} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\rpc_trace /v FileName /t REG_SZ /d "tracelogdir%\%COMPUTERNAME%_boot_rpc_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman rpc_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman rpc_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
   logman stop "rpc_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%rpc_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO rpc_trace has already been started.
exit /b

:USAGE
   ECHO   rpc     collecting RPC services trace.
   ECHO   shacollector.bat trace rpc start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace rpc stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace rpc boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace rpc delete
exit /b