REM =================================================================
REM space     collecting Storage Space trace.
REM =================================================================
REM AA4C798D-D91B-4B07-A013-787F5803D6FC => Microsoft-Windows-StorageSpaces-ManagementAgent
REM 595F7F52-C90A-4026-A125-8EB5E083F15E => Microsoft-Windows-StorageSpaces-Driver
REM 69C8CA7E-1ADF-472B-BA4C-A0485986B9F6 => Microsoft-Windows-StorageSpaces-SpaceManager
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman StorageSpace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%StorageSpace" -ow -o %tracelogdir%\%COMPUTERNAME%_StorageSpace_%logdate%.etl -p {AA4C798D-D91B-4B07-A013-787F5803D6FC} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%StorageSpace" -p {595F7F52-C90A-4026-A125-8EB5E083F15E} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%StorageSpace" -p {69C8CA7E-1ADF-472B-BA4C-A0485986B9F6} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\StorageSpace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_StorageSpace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman StorageSpace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman StorageSpace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "StorageSpace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%StorageSpace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO StorageSpace has already been started.
exit /b

:USAGE
   ECHO   space     collecting Storage Space trace.
   ECHO   shacollector.bat trace space start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace space stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace space boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace space delete
exit /b