REM =================================================================
REM storagereplica     collecting Storage Replica trace.
REM =================================================================
REM 35A2925C-30A3-43EB-B737-03E9659955E2 => Microsoft-Windows-StorageReplica-Cluster
REM CE171FD7-A5BA-4D95-926B-6DC4D89E8171 => Microsoft-Windows-StorageReplica-Service
REM F661B376-6E59-4483-89F8-D5ACA1816EAD => Microsoft-Windows-StorageReplica
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman StorageReplica -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%StorageReplica" -ow -o %tracelogdir%\%COMPUTERNAME%_StorageReplica_%logdate%.etl -p {35A2925C-30A3-43EB-B737-03E9659955E2} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%StorageReplica" -p {CE171FD7-A5BA-4D95-926B-6DC4D89E8171} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%StorageReplica" -p {F661B376-6E59-4483-89F8-D5ACA1816EAD} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\StorageReplica /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_StorageReplica.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman StorageReplica -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman StorageReplica -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "StorageReplica" -ets
   )
   if DEFINED boot (
      logman delete "%boot%StorageReplica"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO StorageReplica has already been started.
exit /b

:USAGE
   ECHO   storagereplica     collecting Storage Replica trace.
   ECHO   shacollector.bat trace storagereplica start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace storagereplica stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace storagereplica boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace storagereplica delete
exit /b