REM =================================================================
REM storport   collecting storport driver trace.
REM =================================================================
REM 8B86727C-E587-4B89-8FC5-D1F24D43F69C => StorPort
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman storport_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%storport_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_storport_trace_%logdate%.etl -p {8B86727C-E587-4B89-8FC5-D1F24D43F69C} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\storport_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_storport_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman storport_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman storport_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "storport_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%storport_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)
exit /b

:DEP
   ECHO storport_trace has already been started.
exit /b

:USAGE
   ECHO   storport   collecting storport driver trace.
   ECHO   shacollector.bat trace storport start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace storport stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace storport boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace storport delete

exit /b