REM =================================================================
REM storsvc     collecting Storage Sensor Service trace.
REM =================================================================
REM A963A23C-0058-521D-71EC-A1CCE6173F21 => Microsoft-Windows-Storsvc
REM F5273E8B-490F-4008-9416-BC6C72AEBFBC => StorageDiskMonitorProvider
REM F4236699-B312-4A7A-923B-AD081AFD7FBE => StorageUsageProvider
REM AEA3A1A8-EA43-4802-B750-2DD678910779 => StorageServiceProvider
REM 778B9D2F-545B-47B0-98E9-28B9B8CA8C6A => StorageHealthProvider
REM 3B6EAB83-3683-4A4E-8382-58A748E0F56D => Microsoft-WindowsPhone-StorageSvc
REM 64B5EBC3-8D00-43CC-A727-47B0DCA85C17 => Microsoft-WindowsPhone-StorageHelper
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman storsvc_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%storsvc_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_storsvc_trace_%logdate%.etl -p {A963A23C-0058-521D-71EC-A1CCE6173F21} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%storsvc_trace" -p {F5273E8B-490F-4008-9416-BC6C72AEBFBC} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%storsvc_trace" -p {F4236699-B312-4A7A-923B-AD081AFD7FBE} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%storsvc_trace" -p {AEA3A1A8-EA43-4802-B750-2DD678910779} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%storsvc_trace" -p {778B9D2F-545B-47B0-98E9-28B9B8CA8C6A} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%storsvc_trace" -p {3B6EAB83-3683-4A4E-8382-58A748E0F56D} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%storsvc_trace" -p {64B5EBC3-8D00-43CC-A727-47B0DCA85C17} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\storsvc_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_storsvc_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (

   logman storsvc_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman storsvc_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "storsvc_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%storsvc_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)

:DEP
   ECHO storsvc_trace has already been started.
exit /b

:USAGE
   ECHO   storsvc     collecting Storage Sensor Service trace.
   ECHO   shacollector.bat trace storsvc start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace storsvc stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace storsvc boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace storsvc delete
exit /b

