REM =================================================================
REM usb       collecting USB drivers trace.
REM =================================================================
REM C88A4EF5-D048-4013-9408-E04B7DB2814A => Microsoft-Windows-USB-USBPORT (USB 2.0)
REM 7426A56B-E2D5-4B30-BDEF-B31815C1A74A => Microsoft-Windows-USB-USBHUB  (USB 2.0)
REM D75AEDBE-CFCD-42B9-94AB-F47B224245DD => usbport (USB 2.0)
REM B10D03B8-E1F6-47F5-AFC2-0FA0779B8188 => usbhub  (USB 2.0)
REM 30E1D284-5D88-459C-83FD-6345B39B19EC => Microsoft-Windows-USB-USBXHCI (USB 3.0)
REM 36DA592D-E43A-4E28-AF6F-4BC57C5A11E8 => Microsoft-Windows-USB-UCX (USB 3.0)
REM AC52AD17-CC01-4F85-8DF5-4DCE4333C99B => Microsoft-Windows-USB-USBHUB3 (USB 3.0)
REM 6E6CC2C5-8110-490E-9905-9F2ED700E455 => USBHUB3 (USB 3.0)
REM 6FB6E467-9ED4-4B73-8C22-70B97E22C7D9 => UCX (USB 3.0)
REM 9F7711DD-29AD-C1EE-1B1B-B52A0118A54C => USBXHCI (USB 3.0)
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman usb_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%usb_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_usb_trace_%logdate%.etl -p {C88A4EF5-D048-4013-9408-E04B7DB2814A} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%usb_trace" -p {7426A56B-E2D5-4B30-BDEF-B31815C1A74A} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {D75AEDBE-CFCD-42B9-94AB-F47B224245DD} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {B10D03B8-E1F6-47F5-AFC2-0FA0779B8188} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {30E1D284-5D88-459C-83FD-6345B39B19EC} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {36DA592D-E43A-4E28-AF6F-4BC57C5A11E8} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {AC52AD17-CC01-4F85-8DF5-4DCE4333C99B} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {6E6CC2C5-8110-490E-9905-9F2ED700E455} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {6FB6E467-9ED4-4B73-8C22-70B97E22C7D9} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%usb_trace" -p {9F7711DD-29AD-C1EE-1B1B-B52A0118A54C} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\usb_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_usb_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman usb_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman usb_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "usb_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%usb_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)
:DEP
   ECHO usb_trace has already been started.
exit /b

:USAGE
   ECHO   usb       collecting USB drivers trace.
   ECHO   shacollector.bat trace usb start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace usb stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace usb boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace usb delete
exit /b