REM =================================================================
REM vds       collecting VDS services trace. (Windows Server 2012 or later)
REM =================================================================
REM 012F855E-CC34-4DA0-895F-07AF2826C03E => VDS
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman vds_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%vds_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_vds_trace_%logdate%.etl -p {012F855E-CC34-4DA0-895F-07AF2826C03E} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\vds_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_vds_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman vds_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman vds_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "vds_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%vds_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)
:DEP
   ECHO vds_trace has already been started.
exit /b

:USAGE
   ECHO   vds       collecting VDS services trace. (Windows Server 2012 or later)
   ECHO   shacollector.bat trace vds start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace vds stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace vds boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace vds delete
exit /b