REM =================================================================
REM vds       collecting VHD trace.
REM =================================================================
REM E2816346-87F4-4F85-95C3-0C79409AA89D => Microsoft-Windows-VHDMP
REM E4480490-85B6-11DD-AD8B-0800200C9A66 => Microsoft-Windows-VDRVROOT
REM A9AB8791-8619-4FFF-9F24-E1BB60075972 => Microsoft-Windows-Hyper-V-VHDMP
REM 3C70C3B0-2FAE-41D3-B68D-8F7FCAF79ADB => VdrvRootTraceGuid
REM 756B2CED-B3CB-5807-9926-8414A27E38F6 => VhdCacheTlgProvRegHandle
REM BB510E5F-2EB9-491A-81E4-F04654388F2B => Microsoft-Windows-Hyper-V-Shared-VHDX
REM F96ABC17-6A5E-4A49-A3F4-A2A86FA03846 => VhdparserTraceGuid
REM 4D20DF22-E177-4514-A369-F1759FEEDEB3 => Microsoft-Windows-VIRTDISK
REM E14DCDD9-D1EC-4DC3-8395-A606DF8EF115 => VirtDiskTraceGuid
REM DAA65A07-D199-48DE-A5B5-3C8244CB5507 => VdrvRootTraceGuid
REM C52D4802-C250-49DD-BBC4-E22B8C8FF6C0 => BttFltTraceGuid
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman vhd_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%vhd_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_vhd_trace_%logdate%.etl -p {E2816346-87F4-4F85-95C3-0C79409AA89D} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%vhd_trace" -p {E4480490-85B6-11DD-AD8B-0800200C9A66} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {A9AB8791-8619-4FFF-9F24-E1BB60075972} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {3C70C3B0-2FAE-41D3-B68D-8F7FCAF79ADB} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {756B2CED-B3CB-5807-9926-8414A27E38F6} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {BB510E5F-2EB9-491A-81E4-F04654388F2B} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {F96ABC17-6A5E-4A49-A3F4-A2A86FA03846} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {4D20DF22-E177-4514-A369-F1759FEEDEB3} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {E14DCDD9-D1EC-4DC3-8395-A606DF8EF115} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {DAA65A07-D199-48DE-A5B5-3C8244CB5507} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%vhd_trace" -p {C52D4802-C250-49DD-BBC4-E22B8C8FF6C0} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\vhd_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_vhd_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman vhd_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman vhd_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "vhd_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%vhd_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)
:DEP
   ECHO vhd_trace has already been started.
exit /b

:USAGE
   ECHO   vds       collecting VHD trace.
   ECHO   shacollector.bat trace vhd start size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace vhd stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace vhd boot size [Maximum log file size in MB (default 4096 MB)] [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace vhd delete
exit /b