REM =================================================================
REM wmi     collecting WMI services trace.
REM =================================================================
REM 1FF6B227-2CA7-40F9-9A66-980EADAA602E => WMI_Tracing
REM 1EDEEE53-0AFE-4609-B846-D8C0B2075B1F => Microsoft-Windows-WMI
REM 1418EF04-B0B4-4623-BF7E-D74AB47BBDAA => Microsoft-Windows-WMI-Activity
REM 1FF6B227-2CA7-40F9-9A66-980EADAA602E => WMI_Tracing_Guid
REM 8E6B6962-AB54-4335-8229-3255B919DD0E => WMI_Tracing_Client_Operations_Info_Guid
REM 2CF953C0-8DF7-48E1-99B9-6816A2FBDC9F => Microsoft-Windows-WMIAdapter
REM =================================================================
REM arg1 = start or stop.
REM arg2 = output dir.
REM arg3 = Maximum log file size in MB
REM arg4 = if boot mode is selected. (autosession\)

SETLOCAL ENABLEDELAYEDEXPANSION
for /f "usebackq tokens=*" %%i in (`powershell Get-Date -Format "yyyy-MMdd-HHmmss"`) do @set logdate=%%i
set tracelogdir=%2
set maxsize=%3
set boot=%4

if /i "%1" =="start" (
   logman wmi_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 goto DEP

   ECHO Log folder is %tracelogdir%.
   ECHO Log size is %maxsize%.
   logman create trace "%boot%wmi_trace" -ow -o %tracelogdir%\%COMPUTERNAME%_wmi_trace_%logdate%.etl -p {1FF6B227-2CA7-40F9-9A66-980EADAA602E} 0xffffffffffffffff 0xff -nb 16 16 -bs 1024 -mode Circular -f bincirc -max %maxsize% -ets
   logman update trace "%boot%wmi_trace" -p {1EDEEE53-0AFE-4609-B846-D8C0B2075B1F} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%wmi_trace" -p {1418EF04-B0B4-4623-BF7E-D74AB47BBDAA} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%wmi_trace" -p {1FF6B227-2CA7-40F9-9A66-980EADAA602E} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%wmi_trace" -p {8E6B6962-AB54-4335-8229-3255B919DD0E} 0xffffffffffffffff 0xff -ets
   logman update trace "%boot%wmi_trace" -p {2CF953C0-8DF7-48E1-99B9-6816A2FBDC9F} 0xffffffffffffffff 0xff -ets

   if DEFINED boot (
      reg add HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\WMI\Autologger\wmi_trace /v FileName /t REG_SZ /d "%tracelogdir%\%COMPUTERNAME%_boot_wmi_trace.etl" /f
   )
   exit /b
) else if /i "%1" =="stop" (
   logman wmi_trace -ets > NUL 2>&1
   if !ERRORLEVEL! EQU 0 (
      for /f "tokens=3 usebackq delims= " %%i in (`logman wmi_trace -ets ^| findstr "Output Location"`) do (
         echo Logfile is %%i
      )
      logman stop "wmi_trace" -ets
   )
   if DEFINED boot (
      logman delete "%boot%wmi_trace"
   )
   echo Tracing has been stopped.
   exit /b
) else (
   goto USAGE
)
:DEP
   ECHO wmi_trace has already been started.
exit /b

:USAGE
   ECHO   wmi     collecting WMI services trace.
   ECHO   shacollector.bat trace wmi start [output folder (default c:\mslog)]
   ECHO   shacollector.bat trace wmi stop
   ECHO   Boot Option:
   ECHO   shacollector.bat trace wmi boot
   ECHO   shacollector.bat trace wmi delete
exit /b