'####################################################################################
'### Name: showVmInfo.vbs
'###
'### Description: show all information related to VMs. 
'### Version: 1.6
'### Author : Microsoft Support
'###
'### History:
'###    Ver1.0: initail version.
'###    Ver1.1: added uptime info for each VMs.
'###    Ver1.2: added Hyper-V global settings.
'###    Ver1.3: added /p(PID) option.
'###    Ver1.4: added /a(Disk ACL) and /v option, KeyExchange info.
'###    Ver1.5: reivsed /p to add GUID info.
'###    Ver1.6: added configuration file to be listed.
'####################################################################################


'####################################################################################
'###                                                                              ###
'###                                   MAIN             f                          ###
'###                                                                              ###
'####################################################################################

if (WScript.arguments.Named.Exists("?")) Then

   showUsage()
   
End If

ShowOSVersion()
Wscript.Echo "NOTE: {XNvg̃T|[g OS  Windows Server 2008 R2 (SSP܂) ݂̂łB"

strComputer = "."
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
Set colItems = objWMIService.ExecQuery("Select * from Win32_UserAccount",,48)

set objWMIService = GetObject("winmgmts:\\.\root\virtualization")


'### /p w莞̓BPID ̕\
if (WScript.arguments.Named.Exists("p")) Then

    showVMPid()
    Wscript.Quit(0)

End If



'### S VM, XibvVbg̕\
showVMInfo()


'####################################################################################
'###                                                                              ###
'###                               Function, Subroutines                          ###
'###                                                                              ###
'####################################################################################
Sub showUsage()

   WScript.Echo "Usage:"
   WScript.Echo "    /p              show PID and GUID for each VMs"
   Wscript.Echo "    /v:[VM Name]    specify VM name"
   Wscript.Echo "    /a              show ACL and VM info (show all info)"
   WScript.Echo ""
   WScript.Quit(0)

End Sub

Sub showVMPid()

   Set objNetWork = WScript.CreateObject("WScript.Network")
   ComputerName = objNetWork.computername

   Set objWMIService = GetObject("winmgmts:\\.\root\virtualization")
   Set VMs = objWMIService.ExecQuery("SELECT * FROM Msvm_ComputerSystem WHERE Name!='" & ComputerName & "'")

   Wscript.Echo ""
   Wscript.Echo "[z OS PID & GUID ]"

   If VMs.count = 0 Then
      
      Wscript.Echo "VM ܂łB"
      Wscript.Quit(0)
      
   End If

   For Each VM in VMs 
 
       query = "ASSOCIATORS OF {" & VM.Path_.Path & "} WHERE resultClass=Msvm_VirtualSystemSettingData AssocClass=Msvm_SettingsDefineState"
       Set VSSettingData = objWMIService.ExecQuery(query).ItemIndex(0)
       strArray = split(VSSettingData.InstanceID, ":")
       guidStr = strArray(1)

       query2 = "ASSOCIATORS OF {" & VM.Path_.Path & "} WHERE resultClass=Msvm_VirtualSystemGlobalSettingData"
       Set VSGlobalSettingData = objWMIService.ExecQuery(query2).ItemIndex(0)

       Wscript.Echo "============================================"
       Wscript.Echo VM.ElementName 

       If VM.ProcessID <> 0 Then
   
          '### PID ̕\
          Wscript.Echo "    PID: " & VM.ProcessID 

       Else

          Wscript.Echo "    PID: NĂ܂" 

       End If

       Wscript.Echo "   GUID: " & guidStr
       Wscript.Echo "\t@C: " & VSGlobalSettingData.ExternalDataRoot & "\Virtual Machines\" & guidStr & ".xml"
       Wscript.Echo "XibvVbgtH_: " & VSGlobalSettingData.SnapshotDataRoot & "\Snapshots"
   Next

End Sub


Sub showVMInfo()

   '### O[oݒ̕\
   query = "SELECT * FROM Msvm_VirtualSystemManagementServiceSettingData"
   Set VSManagementServiceSettingData = objWMIService.ExecQuery(query).ItemIndex(0)

   If IsNull(VSManagementServiceSettingData) Then

      Wscript.Echo "WARNING: Msvm_VirtualSystemManagementServiceSettingData not found."

   Else

      ShowglobalInfo(VSManagementServiceSettingData)

   End If
   
   If (WScript.Arguments.Named.Exists("v")) Then

      '### w肳ꂽVM̏擾query̍쐬
      VMName = WScript.Arguments.Named("v")
      query = "SELECT * FROM Msvm_ComputerSystem WHERE ElementName='" & VMName & "'"

   Else

      '### SVM(zXgOSȊO)̏擾query̍쐬
      Set objNetWork = WScript.CreateObject("WScript.Network")
      ComputerName = objNetWork.computername
      query = "SELECT * FROM Msvm_ComputerSystem WHERE ElementName!='" & ComputerName & "'"

   End If

   '### Msvm_ComputerSystem ̎擾
   Set VMs = objWMIService.ExecQuery(query)

   If VMs.count = 0 Then

      Wscript.Echo "ERROR: VM(" & VMName & ") ݂܂Bēx VM mFĂB"
      Wscript.Echo ""
      showUsage()
      Wscript.Quit(1)

   End If

   For Each VM in VMs

      Wscript.Echo ""
      Wscript.Echo ""
      Wscript.Echo "   z}V: " & VM.ElementName
      Wscript.Echo ""
      Wscript.Echo ""
      Wscript.Echo ""

      '### z}V Msvm_VirtualSystemGlobalSettingData ̎擾
      query = "ASSOCIATORS OF {" & VM.Path_.Path & "} WHERE resultClass=Msvm_VirtualSystemGlobalSettingData"
      Set VSGlobalSettingData = objWMIService.ExecQuery(query).ItemIndex(0)

      '### z}ṼJg̗Lݒ Msvm_VirtualSystemSettingData ̎擾
      query = "ASSOCIATORS OF {" & VM.Path_.Path & "} WHERE resultClass=Msvm_VirtualSystemSettingData AssocClass=Msvm_SettingsDefineState"
      Set VSSettingData = objWMIService.ExecQuery(query).ItemIndex(0)

      '### z}V{̕\(Msvm_VirtualSystemSettingData)
      Call ShowBasicVMInfo(VM, VSSettingData)

      '### QXg OS ̃o[W IP ̕\
      
      If VM.EnabledState = 2 Then

         ShowGuestInfo(VM)

      End If

      '### BIOS ݒ̕\(Msvm_VirtualSystemSettingData)
      ShowBIOS(VSSettingData)

      '### Memory ݒ̕\(Msvm_MemorySettingData)
      ShowMemory(VSSettingData)

      '### vZbTݒ̕\(Msvm_ProcessorSettingData)
      ShowProcessor(VSSettingData)

      '### IDE Rg[ݒ̕\(Msvm_ResourceAllocationSettingData)
      ShowIDEDevice(VSSettingData)

      '### SCSI Rg[ݒ̕\(Msvm_ResourceAllocationSettingData)
      ShowSCSIDevice(VSSettingData)

      '### lbg[Nݒ̕\(Msvm_SyntheticEthernetPortSettingData/Msvm_EmulatedEthernetPortSettingData)
      ShowNetworkDevice(VSSettingData)

      '### COM |[gݒ̕\(Msvm_ResourceAllocationSettingData.ResourceType=17)
      ShowSerialPort(VSSettingData)

      '### tbs[fBXNݒ̕\(Msvm_ResourceAllocationSettingData.ResourceType=21)
      ShowFloppyDevice(VSSettingData)
         
      '### O̕\
      Wscript.Echo "   [O]"
      Wscript.Echo "   O: " & VSSettingData.ElementName
      Wscript.Echo "   : " & VSSettingData.Notes
      Wscript.Echo ""
      
      '### T[rX̕\
      ShowIntegrationService(VSSettingData)

      '### tH_pX̕\
      Wscript.Echo "   [\t@CۑtH_]"
      Wscript.Echo "   tH_pX: " & VSGlobalSettingData.ExternalDataRoot & "\Virtual Machines"
      Wscript.Echo ""
      Wscript.Echo "   [XibvVbg\t@CۑtH_]"
      Wscript.Echo "   tH_pX: " & VSGlobalSettingData.SnapshotDataRoot & "\Snapshots"
      Wscript.Echo ""

      '### JnANV̕\
      Wscript.Echo "   [JnANV]"
      Wscript.Echo "   JnANV: " & DecodeAutomaticStartupAction(VSGlobalSettingData.AutomaticStartupAction)
      Wscript.Echo "   N҂  : " & VSGlobalSettingData.AutomaticStartupActionDelay
      Wscript.Echo ""

      '### ~ANV̕\
      Wscript.Echo "   [~ANV]"
      Wscript.Echo "   ~ANV: " & DecodeAutomaticShutdownAction(VSGlobalSettingData.AutomaticShutdownAction)
      
      Set objShell = WScript.CreateObject("WScript.Shell")
      ShutdownTimeout = objShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Virtualization\ShutdownTimeout")

      If Err.Number <> 0 Then

         Wscript.Echo "   ~҂  : "
         Wscript.Echo  "   WARNING: ShutdownTimeout WXg̓ǂݍ݂Ɏs܂B"
         Wscript.Echo "   " & Err.Number & ":" & Err.description
         Err.clear
         
      Else
      
         Wscript.Echo "   ~҂  : " & ShutdownTimeout & " "
         
      End If
      Wscript.Echo ""
      
      '### ACL ̕\(/a IvV̏ꍇ̂)
      If (WScript.arguments.Named.Exists("a")) Then

         call showConfigAcl(VM, VSGlobalSettingData.ExternalDataRoot, VSGlobalSettingData.SnapshotDataRoot)

      End If

      '### RemoteFX̕\(_Ŗ)
      'ShowRemoteFXInfo(VSSettingData.ElementName)
      
      Wscript.Echo ""
      Wscript.Echo ""

      '###
      '### eXibvVbgݒ̕\
      '###
      query = "ASSOCIATORS OF {" & VM.Path_.Path & "} WHERE resultClass=Msvm_VirtualSystemSettingData AssocClass=Msvm_ElementSettingData"
      Set VSSnapShotSettingDataArray = objWMIService.ExecQuery(query)

      For Each VSSnapShotSettingData in VSSnapShotSettingDataArray 

         Wscript.Echo " XibvVbg(" & VSSnapShotSettingData.ElementName & ") "
         
         '### z}V{̕\(Msvm_VirtualSystemSettingData)
         ShowBasicSnapShotInfo(VSSnapShotSettingData)

         '### BIOS ݒ̕\(Msvm_VirtualSystemSettingData)
         ShowBIOS(VSSnapShotSettingData)

         '### Memory ݒ̕\(Msvm_MemorySettingData)
         ShowMemory(VSSnapShotSettingData)

         '### vZbTݒ̕\(Msvm_ProcessorSettingData)
         ShowProcessor(VSSnapShotSettingData)

         '### IDE Rg[ݒ̕\(Msvm_ResourceAllocationSettingData)
         ShowIDEDevice(VSSnapShotSettingData)

         '### SCSI Rg[ݒ̕\(Msvm_ResourceAllocationSettingData)
         ShowSCSIDevice(VSSnapShotSettingData)

         '### lbg[Nݒ̕\(Msvm_SyntheticEthernetPortSettingData/Msvm_EmulatedEthernetPortSettingData)
         ShowNetworkDevice(VSSnapShotSettingData)

         '### COM |[gݒ̕\(Msvm_ResourceAllocationSettingData.ResourceType=17)
         ShowSerialPort(VSSnapShotSettingData)

         '### tbs[fBXNݒ̕\(Msvm_ResourceAllocationSettingData.ResourceType=21)
         ShowFloppyDevice(VSSettingData)
         
         '### O̕\
         Wscript.Echo "   [O]"
         Wscript.Echo "   O: " & VSSnapShotSettingData.ElementName
         Wscript.Echo "   : " & VSSnapShotSettingData.Notes
         Wscript.Echo ""

         '### T[rX̕\
         ShowIntegrationService(VSSnapShotSettingData)
           
      Next

      Wscript.Echo ""

   Next


End Sub


Sub showVHDAcl(vhdPath)

   Wscript.Echo ""
   Wscript.Echo "   [VHDt@C ACL ]"
   CommandLine = "cacls " & vhdPath & " /T"
   Set objShell = CreateObject("Wscript.Shell")
   Set objExec = objShell.Exec (CommandLine)
   Wscript.Echo objExec.Stdout.ReadALL
   Wscript.Echo ""

End Sub

'###
'###  showConfigAcl(VM, configPath)


Sub showConfigAcl(VM, confPath, snapShotConfPath)

   Set objShell = CreateObject("Wscript.Shell")

   Wscript.Echo "##############################################################################"
   Wscript.Echo "###                                                                        ###"
   Wscript.Echo "### \t@C ACL                                                   ###"
   Wscript.Echo "###                                                                        ###"
   Wscript.Echo "##############################################################################"
   Wscript.Echo ""

   configFileName = VM.name & ".xml"
   confFolderCmdStr = "icacls """ & confPath & "\Virtual Machines" & """"
   confCmdStr = "icacls """ & confPath & "\Virtual Machines\" & configFileName & """"

   Wscript.Echo "   [\t@CtH_]"
   Set objExec = objShell.Exec(confFolderCmdStr)
   WScript.Echo objExec.Stdout.ReadALL
   Wscript.Echo "   [\t@C]"
   Set objExec = objShell.Exec(confCmdStr)
   WScript.Echo objExec.Stdout.ReadALL

   Wscript.Echo "### V{bNN̂ɑ΂ ACL "
   confCmdStr_symlink = "icacls """ & confPath & "\Virtual Machines\" & configFileName & """" & " /L"
   Set objExec = objShell.Exec(confCmdStr_symlink)
   WScript.Echo objExec.Stdout.ReadALL

   query = "ASSOCIATORS OF {" & VM.Path_.Path & "} WHERE resultClass=Msvm_VirtualSystemSettingData AssocClass=Msvm_ElementSettingData"
   Set VSSnapShotSettingDataArray = objWMIService.ExecQuery(query)

   '### XibvVbg݂Ȃꍇexit
   If VSSnapShotSettingDataArray.count =  0 Then
      
      Exit Sub
      
   End If
   
   Wscript.Echo "##############################################################################"
   Wscript.Echo "###                                                                        ###"
   Wscript.Echo "### XibvVbg\t@C ACL                                   ###"
   Wscript.Echo "###                                                                        ###"
   Wscript.Echo "##############################################################################"
   Wscript.Echo ""
   
   snapshotConfCmdStr = "icacls " & snapShotConfPath & "\Snapshots\* /T"
   Wscript.Echo "   [XibvVbg\t@CtH_]"
   Set objExec = objShell.Exec(snapshotConfCmdStr)
   WScript.Echo objExec.Stdout.ReadALL


End Sub

'###
'### ShowOSVersion()
'###
Function ShowOSVersion()

   Set objNetWork = WScript.CreateObject("WScript.Network")
   WScript.Echo "HostName    : " & objNetWork.computername

   Set obj = GetObject("winmgmts:\\.\root\cimv2")
   Set colTarget = obj.ExecQuery( "select * from Win32_OperatingSystem" )

   For Each objRow in colTarget

      str = objRow.Version
      Wscript.Echo "OS Version  : " & objRow.caption
      
      If IsNull(objRow.CSDVersion) Then

         Wscript.Echo "Service Pack: SPȂ"

      Else

         Wscript.Echo "Service Pack: " & objRow.CSDVersion

      End If

   Next

   Wscript.Echo ""
   GetOSVersion = str

End Function

'###
'### ShowglobalInfo()
'###
Sub ShowglobalInfo(VSManagementServiceSettingData)

   Wscript.Echo ""
   Wscript.Echo "                                                                  "
   Wscript.Echo " Hyper-V Gloval Setting Data                                      "
   Wscript.Echo "                                                                  "
   Wscript.Echo ""
   Wscript.Echo ""
   Wscript.Echo "   [T[o[]"
   Wscript.Echo "   VHD t@CftHgۑ: " & VSManagementServiceSettingData.DefaultVirtualHardDiskPath
   Wscript.Echo "   \t@CftHgۑ: " & VSManagementServiceSettingData.DefaultExternalDataRoot
   Wscript.Echo "   z}V NUMA m[h܂郁蓖Ă: " & VSManagementServiceSettingData.NumaSpanningEnabled
   Wscript.Echo ""
End Sub

'###
'### ShowBasicVMInfo()
'###
Sub ShowBasicVMInfo(VM, VSSettingData)

      '### GUID ̕H
      strArray = split(VSSettingData.InstanceID, ":")
      guidStr = strArray(1)
      
      Wscript.Echo "   O        : " & VSSettingData.ElementName
      Wscript.Echo "   쐬      : " & VSSettingData.CreationTime
      Wscript.Echo "   GUID        : " & guidStr 
      Wscript.Echo "   ^Cv      : " & VSSettingData.Description
      Wscript.Echo "           : " & DecodeEnableStatus(VM.EnabledState)
      Wscript.Echo "   Xe[^X  : " & DecodeHealthState(VM.HealthState)

      If VM.ProcessID = 0 Then

         pid = "N/A (VM ͋NĂ܂)"

      Else 
      
         pid = VM.ProcessID
         
      End If
      
      Wscript.Echo "   PID         : " & pid
      
      If Len(VSSettingData.Parent) <> 0 Then

         '### Parent ̕H
         strArray = split(VSSettingData.Parent, "=")
         str = replace(strArray(1), """", "")
         parent = replace(str, "Microsoft:", "")
         Wscript.Echo "   Parent GUID : " & parent
         
      Else
         
         If VSSettingData.SettingType = 5 Then
         
            Wscript.Echo "   Parent GUID : ŏ̃XibvVbgłB"

         Else
         
            Wscript.Echo "   Parent GUID : XibvVbg͂܂B"
            
         End If
         
      End If
      
      Wscript.Echo "   ғ    : " & VM.OnTimeInMilliseconds
      Wscript.Echo "   ŏIXe[^XύX : " & VM.TimeOfLastStateChange
      Wscript.Echo "   ŏI\ύX   : " & VM.TimeOfLastConfigurationChange
      
      Wscript.Echo ""
      
End Sub

'###
'### ShowBasicSnapShotInfo()
'###
Function ShowBasicSnapShotInfo(VSSettingData)

      '### GUID ̕H
      strArray = split(VSSettingData.InstanceID, ":")
      guidStr = strArray(1)
      
      Wscript.Echo "   O        : " & VSSettingData.ElementName
      Wscript.Echo "   쐬      : " & VSSettingData.CreationTime
      Wscript.Echo "   GUID        : " & guidStr 
      Wscript.Echo "   ^Cv      : " & VSSettingData.Description
            
      If Len(VSSettingData.Parent) <> 0 Then

         '### Parent ̕H
         strArray = split(VSSettingData.Parent, "=")
         str = replace(strArray(1), """", "")
         parent = replace(str, "Microsoft:", "")
         Wscript.Echo "   Parent GUID : " & parent
         
      Else
         
         If VSSettingData.SettingType = 5 Then
         
            Wscript.Echo "   Parent GUID : ŏ̃XibvVbgłB"

         Else
         
            Wscript.Echo "   Parent GUID : XibvVbg͂܂B"
            
         End If
         
      End If
      
      Wscript.Echo ""
      
End Function


'###
'### ShowBIOS()
'###
function ShowBIOS(VSSettingData)
   Wscript.Echo "   [BIOS]"
   Wscript.Echo "   NumLock  : " & VSSettingData.BIOSNumLock
   WScript.StdOut.Write "   BootOrder: " & DecodeBootOrder(VSSettingData.BootOrder(0))

   count = UBound(VSSettingData.BootOrder)

   For i = 1 To count Step 1

      WScript.StdOut.Write " -> " & DecodeBootOrder(VSSettingData.BootOrder(i)) 

   Next

   Wscript.Echo ""
   Wscript.Echo ""

End Function


'###
'### DecodeBootOrder()
'###
function DecodeBootOrder(bootorder)

    Dim deviceName 

    Select case bootorder
        case 0
            deviceName = "Floppy"
        case 1
            deviceName = "CD-ROM"
        case 2
            deviceName = "Hard Drive"
        case 3
            deviceName = "PXE Boot"
    End Select

    DecodeBootOrder = deviceName

End Function


'###
'### ShowMemory()
'###
function ShowMemory(VSSettingData)

   On Error Resume Next 

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_MemorySettingData"
   Set MemorySettingData = objWMIService.ExecQuery(query).ItemIndex(0)

   Wscript.Echo "   [MEMORY]"

   '### W2K8R2 p̕(_Ci~bNT|[g)
   If IsNull(MemorySettingData.DynamicMemoryEnabled) Then

      Wscript.Echo "      X^[gAbv RAM: " & MemorySettingData.VirtualQuantity & " MB"
      Wscript.Echo ""

      Exit function

   End If

   Wscript.Echo "   _Ci~bN: " & MemorySettingData.DynamicMemoryEnabled

   '### W2K8R2 SP1 ȍ~̏ꍇ̂ݒʉ߂(_Ci~bNݒ莞)
   If NOT MemorySettingData.DynamicMemoryEnabled Then

      Wscript.Echo "   ÓI              : " & MemorySettingData.Limit & " MB"

   '### W2K8R2 SP1 ȍ~̏ꍇ̂ݒʉ߂(_Ci~bNݒ莞)
   Else

      Wscript.Echo "   I(_Ci~bN): " 
      Wscript.Echo "      X^[gAbv RAM: " & MemorySettingData.VirtualQuantity & " MB"
      Wscript.Echo "                ő RAM: " & MemorySettingData.Limit & " MB"
      Wscript.Echo "   obt@: " & MemorySettingData.TargetMemoryBuffer & " %"

      '### yAgp[eBṼTCYݒ莞͂̃TCY\
      Set objShell = WScript.CreateObject("WScript.Shell")
      MemoryReserve = objShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Virtualization\MemoryReserve")

      If Err.Number <> 0 Then
      
         Wscript.Echo "   yAgp[eBVTCY  : MemoryReserve ͐ݒ肳Ă܂B"
         'Wscript.Echo "   " & Err.Number & ":" & Err.description
         Err.clear
         
      Else

         Wscript.Echo "   yAgp[eBVTCY  : " & MemoryReserve & " MB"
         
      End If
   
   
   End If

   Wscript.Echo "   ̗Dx    : " & MemorySettingData.Weight
   Wscript.Echo ""

End Function


'###
'### ShowProcessor()
'###
function ShowProcessor(VSSettingData)

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_ProcessorSettingData"
   Set ProcessorSettingData = objWMIService.ExecQuery(query).ItemIndex(0)

   Wscript.Echo "   [CPU]"
   Wscript.Echo "   _vZbT̐ : " & ProcessorSettingData.VirtualQuantity
   Wscript.Echo "   z}V̗\(%): " & ProcessorSettingData.Reservation/1000 & "%"
   Wscript.Echo "   z}V̌x(%): " & ProcessorSettingData.Limit/1000 & "%"
   Wscript.Echo "   ΓIȏd       : " & ProcessorSettingData.Weight
   Wscript.Echo "   vZbT o[WقȂ镨Rs[^ֈڍs: " & ProcessorSettingData.LimitProcessorFeatures
   Wscript.Echo "   Windows NT Ȃǂ̌ÂIy[eBO VXes: " & ProcessorSettingData.LimitCPUID
   Wscript.Echo ""

End Function


'###
'### ShowIDEDevice()
'###
function ShowIDEDevice(VSSettingData)

   driveCount = 0
   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_ResourceAllocationSettingData"
   Set ResAllocSettingDataArray = objWMIService.ExecQuery(query)

   Wscript.Echo "   [IDE Rg[]"

   For Each ResAllocSettingData in ResAllocSettingDataArray

      '### IDE Rg[̎擾
      IF ResAllocSettingData.ResourceType = 5 Then

         Set IDEController = ResAllocSettingData
         Wscript.Echo "   " & ResAllocSettingData.ElementName    '### IDE Rg[
         
         '### ׂĂ̖{VSSettingDataɊ֘Atꂽ Msvm_ResourceAllocationSettingData IDEfoCX擾
         For Each IDEDevice In ResAllocSettingDataArray 

            If IDEDevice.Parent = IDEController.Path_.Path Then

               Wscript.Echo "      " & IDEDevice.ElementName

               IF IDEDevice.ResourceType = 22 Then          '### n[hhCu

                  Wscript.Echo "         ꏊ: " & IDEDevice.Address

                  '### n[hfBXNC[Wppath쐬
                  str = IDEController.Address & """"
                  parentPath = Replace(IDEDevice.Parent, str, IDEController.Address)
                  parent = parentPath  & "\\" & IDEDevice.Address & "\\D"""

                  For Each Device In ResAllocSettingDataArray 

                     If Device.Parent = parent Then          '### n[hfBXNC[W

                        Wscript.Echo "         zn[hfBXN(.VHD) t@C: " & Device.Connection(0)

                        '### /a option
                        If (WScript.arguments.Named.Exists("a")) Then

                           showVHDAcl(Device.Connection(0))

                        End If

                     End If


                  Next

               ElseIf IDEDevice.ResourceType = 16 Then    '### DVD hCu

                  Wscript.Echo "         ꏊ: " & IDEDevice.Address

                  str = IDEController.Address & """"
                  parentPath = Replace(IDEDevice.Parent, str, IDEController.Address)
                  parent = parentPath  & "\\" & IDEDevice.Address & "\\D"""

                  For Each Device In ResAllocSettingDataArray 

                     If Device.Parent = parent Then     '### ISO fBXNC[W ("Ȃ"̏ꍇ͂̕ɓȂ)

                         driveCount = driveCount + 1
                         Wscript.Echo "         C[W t@C: " & Device.Connection(0)

                     End If

                  Next

                  '### "Ȃ"̐ݒ莞 'CD/DVDhCu' ^Cv Msvm_ResourceAllocationSettingData 
                  '### ݂͑ALɓ 
                  If driveCount = 0 Then

                     Wscript.Echo "         fBA: Ȃ"

                  End If

               End If 

            End If

         Next

      End If

   Next

   Wscript.Echo ""

End Function


'###
'### ShowSCSIDevice()
'###
function ShowSCSIDevice(VSSettingData)

   Dim SCSIDeviceCount 
  
   SCSIDeviceCount = 0

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_ResourceAllocationSettingData"
   Set ResAllocSettingDataArray = objWMIService.ExecQuery(query)

   Wscript.Echo "   [SCSI Rg[]"

   For Each ResAllocSettingData in ResAllocSettingDataArray

      '### SCSI Rg[̎擾
      IF ResAllocSettingData.ResourceType = 6 Then

         Set SCSIController = ResAllocSettingData
         Wscript.Echo "   " & SCSIController.ElementName    '### SCSI Rg[
         
         '### ׂĂ̖{VSSettingDataɊ֘Atꂽ Msvm_ResourceAllocationSettingData SCSIfoCX擾
         For Each SCSIDevice In ResAllocSettingDataArray 

            If SCSIDevice.Parent = SCSIController.Path_.Path Then

               Wscript.Echo "      " & SCSIDevice.ElementName

               IF SCSIDevice.ResourceType = 22 Then          '### n[hhCu

                  SCSIDeviceCount = SCSIDeviceCount + 1
                  Wscript.Echo "         ꏊ: " & SCSIDevice.Address

                  '### n[hfBXNC[Wppath쐬
                  str = "0"""   '### SCSI Rg[ 0 Œ
                  parentPath = Replace(SCSIDevice.Parent, str, "0")
                  parent = parentPath  & "\\" & SCSIDevice.Address & "\\D"""

                  For Each Device In ResAllocSettingDataArray 

                     If Device.Parent = parent Then          '### n[hfBXNC[W
                        Wscript.Echo "         zn[hfBXN(.VHD) t@C: " & Device.Connection(0)

                        '### /a option
                        If (WScript.arguments.Named.Exists("a")) Then

                           showVHDAcl(Device.Connection(0))

                        End If

                     End If

                  Next

               End If 

            End If

         Next

         If SCSIDeviceCount = 0 Then
         
            Wscript.Echo "      SCSI foCX͐ڑĂ܂B"
            
         End If
         
      End If

   Next
   
   Wscript.Echo ""

End Function


'###
'### ShowNetworkDevice()
'###
function ShowNetworkDevice(VSSettingData)

   Wscript.Echo "   [lbg[N]"

   '### KV lbg[N A_v^[(Msvm_EmulatedEthernetPortSettingData)̎擾
   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_EmulatedEthernetPortSettingData"
   Set EmulatedEthernetPortSettingDataArray = objWMIService.ExecQuery(query)
   
   '### KV lbg[N A_v^[̏\
   For Each EmulatedEthernetPortSettingData In EmulatedEthernetPortSettingDataArray

      ShowNetworkDetailInfo(EmulatedEthernetPortSettingData)
      Wscript.Echo ""
      
   Next

   '### lbg[N A_v^[ (Msvm_SyntheticEthernetPortSettingData) ̎擾
   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_SyntheticEthernetPortSettingData"
   Set SyntheticEthernetPortSettingDataArray = objWMIService.ExecQuery(query)
   
   '### lbg[N A_v^[̏\
   For Each SyntheticEthernetPortSettingData In SyntheticEthernetPortSettingDataArray

      ShowNetworkDetailInfo(SyntheticEthernetPortSettingData)
      Wscript.Echo ""
      
   Next
   

   Wscript.Echo ""
   
End Function


'###
'### Function for showing network detail info.
'###
function ShowNetworkDetailInfo(EthernetPortSettingData)

   On Error Resume Next
   
   Wscript.Echo "   " & EthernetPortSettingData.ElementName
   
   If Len(EthernetPortSettingData.connection(0)) = 0 Then

      Wscript.Echo "      lbg[N: ڑĂ܂B"
      Exit function
      
   End If
   
   '### Msvm_VitualSwich  GUID ̎擾
   str = Replace(EthernetPortSettingData.connection(0), ",", "")
   str2 = Replace(str, """","")
   strArray = split(str2, "=")
   virtualSwitchGUID = strArray(4)
   
   '### Msvm_SwitchPort  GUID ̎擾
   switchPortGUID = Replace(strArray(2), "SystemCreationClassName", "")
   
   Wscript.Echo "      SwitchPort: " & switchPortGUID
   Wscript.Echo "      VirtualSwitch: " & virtualSwitchGUID

   '#### Msvm_VitualSwich ̎擾
   query = "SELECT * FROM Msvm_VirtualSwitch WHERE Name='" & virtualSwitchGUID & "'"
   Set VirtualSwitch = objWMIService.ExecQuery(query).ItemIndex(0)

   If Err.Number <> 0 Then
   
      Wscript.Echo "      lbg[N: \G["
      Err.clear
      Exit Function
      
   End If
   
   Wscript.Echo "      lbg[N: " & VirtualSwitch.ElementName
   
   '#### Msvm_SwitchPort ̎擾
   query = "SELECT * FROM Msvm_SwitchPort WHERE Name='" & switchPortGUID & "'"
   Set switchPort = objWMIService.ExecQuery(query).ItemIndex(0)
   
   If Err.Number <> 0 Then

      Wscript.Echo "      zXCb`|[g(Msvm_SwitchPort)݂Ă܂B(" & switchPortGUID & ")"
      Exit Function
      
   End If
   
   If EthernetPortSettingData.StaticMacAddress Then
      
      Wscript.Echo "      ÓI"
      
   Else
      
      Wscript.Echo "      I"
      
   End If

   Wscript.Echo "      MAC: " & EthernetPortSettingData.address
   Wscript.Echo "      MAC AhX̃Xv[tBOLɂ: " & switchPort.AllowMacSpoofing

   '### Msvm_VLANEndpoint ̎擾
   query = "ASSOCIATORS OF {" &  switchport.Path_.Path & "} WHERE resultClass=Msvm_VLANEndpoint"
   Set vlanEndPoint = objWMIService.ExecQuery(query).ItemIndex(0)

   '### Msvm_VLANEndpoint ̎擾
   query = "ASSOCIATORS OF {" &  vlanEndPoint.Path_.Path & "} WHERE resultClass=Msvm_VLANEndpointSettingData"
   Set vlanEndPointSettingData = objWMIService.ExecQuery(query).ItemIndex(0)

   If vlanEndPointSettingData.AccessVLAN <> 0 Then

      Wscript.Echo "      z VLAN Lɂ: true"
      Wscript.Echo "         VLAN ID: " & vlanEndPointSettingData.AccessVLAN
      Wscript.Echo "         VLAN Mode: " & DecodeVlanMode(vlanEndPoint.DesiredEndpointMode)

   Else
   
      Wscript.Echo "      z VLAN Lɂ: false"
      
   End If

End Function


'###
'### Function for decoding Msvm_VLANEndpoint.DesiredEndpointMode
'### See http://msdn.microsoft.com/en-us/library/cc136946(v=VS.85).aspx
'###
function DecodeVlanMode(mode)

    Select case mode
        case 0
            vlanMode = "DMTF Reserved(0)"
        case 1
            vlanMode = "Other(1)"
        case 2
            vlanMode = "Access(2)"
        case 3
            vlanMode = "Dynamic Auto(3)"
        case 4
            vlanMode = "Dynamic Desirable(4)"
        case 5
            vlanMode = "Trunk(5)"
        case 6
            vlanMode = "Dot1Q Tunnel(6)"
    End Select

    DecodeVlanMode = vlanMode

End Function

'###
'### Function for showing COM port info.
'###
function ShowSerialPort(VSSettingData)

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_ResourceAllocationSettingData"
   Set ResAllocSettingDataArray = objWMIService.ExecQuery(query)

   Wscript.Echo "   [COM |[g]"

   For Each ResAllocSettingData in ResAllocSettingDataArray

      If ResAllocSettingData.ResourceType = 17 Then
      
         Wscript.Echo "   " & ResAllocSettingData.ElementName
         
         If Len(ResAllocSettingData.connection(0)) = 0 Then
         
            Wscript.Echo "      A^b`gFȂ"
         
         Else
         
            Wscript.Echo "      A^b`gF (" & ResAllocSettingData.connection(0) & ")"

         End If
      
      
      End If
   Next
   
   Wscript.Echo ""
   
End Function


'###
'### Function for showing Floppy device info.
'###
function ShowFloppyDevice(VSSettingData)

   count = 0
   
   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE AssocClass=Msvm_VirtualSystemSettingDataComponent ResultClass=Msvm_ResourceAllocationSettingData"
   Set ResAllocSettingDataArray = objWMIService.ExecQuery(query)

   Wscript.Echo "   [tbs[ fBXN hCu]"

   For Each ResAllocSettingData in ResAllocSettingDataArray

      If ResAllocSettingData.ResourceType = 21 AND ResAllocSettingData.ResourceSubType = "Microsoft Virtual Floppy Disk" Then
      
         Wscript.Echo "   fBAF (" & ResAllocSettingData.connection(0) & ")"
         count = count + 1

      End If

   Next
   
   If count = 0 Then

      Wscript.Echo "   fBAFȂ"

   End If
   
   Wscript.Echo ""
   
End Function

'###
'### Function for showing enableState for all of IS components.
'### See http://msdn.microsoft.com/en-us/library/cc136801(v=VS.85).aspx
'###
function ShowIntegrationService(VSSettingData)

   Wscript.Echo "   [T[rX]"
   
   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE ResultClass=Msvm_ShutdownComponentSettingData AssocClass=Msvm_VirtualSystemSettingDataComponent"
   Set ShutdownComponentSettingData = objWMIService.ExecQuery(query).ItemIndex(0)
   Wscript.Echo "      " & ShutdownComponentSettingData.ElementName & ": " & DecodeISEnableState(ShutdownComponentSettingData.EnabledState)

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE ResultClass=Msvm_TimeSyncComponentSettingData AssocClass=Msvm_VirtualSystemSettingDataComponent"
   Set TimeSyncComponentSettingData = objWMIService.ExecQuery(query).ItemIndex(0)
   Wscript.Echo "      " & TimeSyncComponentSettingData.ElementName & "    : " & DecodeISEnableState(TimeSyncComponentSettingData.EnabledState)

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE ResultClass=Msvm_KvpExchangeComponentSettingData AssocClass=Msvm_VirtualSystemSettingDataComponent"
   Set KvpExchangeComponentSettingData = objWMIService.ExecQuery(query).ItemIndex(0)
   Wscript.Echo "      " & KvpExchangeComponentSettingData.ElementName & ": " & DecodeISEnableState(KvpExchangeComponentSettingData.EnabledState)

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE ResultClass=Msvm_HeartbeatComponentSettingData AssocClass=Msvm_VirtualSystemSettingDataComponent"
   Set HeartbeatComponentSettingData = objWMIService.ExecQuery(query).ItemIndex(0)
   Wscript.Echo "      " & HeartbeatComponentSettingData.ElementName & "  : " & DecodeISEnableState(HeartbeatComponentSettingData.EnabledState)

   query = "ASSOCIATORS OF {" & VSSettingData.Path_.Path & "} WHERE ResultClass=Msvm_VssComponentSettingData AssocClass=Msvm_VirtualSystemSettingDataComponent"
   Set VssComponentSettingData = objWMIService.ExecQuery(query).ItemIndex(0)
   Wscript.Echo "      " & VssComponentSettingData.ElementName & "           : " & DecodeISEnableState(VssComponentSettingData.EnabledState)
   
   Wscript.Echo ""
   
End Function

'###
'###  Function for showing gesut OS / NetworkAddress
'###
function ShowGuestInfo(targetVM)

   Wscript.Echo "   [QXg OS ]"

   query = "ASSOCIATORS OF {" & targetVM.Path_.Path & "} WHERE ResultClass=Msvm_KvpExchangeComponent AssocClass=Msvm_SystemDevice"
   Set KvpExchangeComponent = objWMIService.ExecQuery(query).ItemIndex(0)

   Set xmlDoc = CreateObject("Microsoft.XMLDOM")
   xmlDoc.async = "false"

   On Error Resume Next
   For Each exchangeDataItem in KvpExchangeComponent.GuestIntrinsicExchangeItems
  
      xmlDoc.loadXML(exchangeDataItem) 
      '### l̎擾
      xpath = "/INSTANCE/PROPERTY[@NAME='Name']/VALUE/child:text()"
      set valueXML = xmlDoc.selectSingleNode(xpath)
      valueString = valueXML.text
      
      '### f[^̎擾
      xpath = "/INSTANCE/PROPERTY[@NAME='Data']/VALUE/child:text()"
      set dataXML = xmlDoc.selectSingleNode(xpath)
      dataString = dataXML.text

      If Err.number <> 0Then
         
         displayString = "   " & valueString & ": NULL"
         
      Else
      
          displayString = "   " & valueString & ": " & dataString
      
      End If

      Wscript.echo displayString 

      If valueString = "IntegrationServicesVersion" Then
         call ISVersionCheck(exchangeDataItem, dataString)
      End If
      
   Next
   On Error GoTo 0
   
   Wscript.echo ""

End Function

'###
'### ISVersionCheck()
'###
Sub ISVersionCheck(exchangeDataItem, guestISVersion)

      '### zXg OS  IS o[W
      Set objShell = WScript.CreateObject("WScript.Shell")
      hostISVersion = objShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Virtualization\GuestInstaller\Version\Microsoft-Hyper-V-Guest-Installer-Win60-Package")

      If hostISVersion <> guestISVersion Then

         Wscript.Echo "   !!!WARNING: T[rX̃o[WقȂ܂B" & "Host=" & hostISVersion & ", Guest=" &  guestISVersion

      End If
      

End Sub


'###
'###  Function RemoteFX Infomation(ݖgp)
'###
function ShowRemoteFXInfo(targetVM)

   Wscript.Echo "   [RemoteFX]"

   Set VMs = objWMIService.ExecQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName='" & targetVM & "'")

   if VMs.Count < 1 then

      WScript.Echo targetVM & " ܂B"
      WScript.Quit

   end if

   Select Case VMs.ItemIndex(0).EnabledState
   Case 2 's

      Set SDC = (VMs.ItemIndex(0).Associators_("Msvm_SystemDevice", "Msvm_S3DisplayController")).ItemIndex(0) 
      Wscript.Echo "      AcceleratorCapabilities       :" & SDC.AcceleratorCapabilities(0)
      Wscript.Echo "      AdditionalAvailability        :" & SDC.AdditionalAvailability(0)
      Wscript.Echo "      Availability                  :" & SDC.Availability
      Wscript.Echo "      CapabilityDescriptions        :" & SDC.CapabilityDescriptions(0)
      Wscript.Echo "      Caption                       :" & SDC.Caption
      Wscript.Echo "      CreationClassName             :" & SDC.CreationClassName
      Wscript.Echo "      Description                   :" & SDC.Description
      Wscript.Echo "      DeviceID                      :" & SDC.DeviceID
      Wscript.Echo "      ElementName                   :" & SDC.ElementName
      Wscript.Echo "      EnabledDefault                :" & SDC.EnabledDefault
      Wscript.Echo "      EnabledState                  :" & SDC.EnabledState
      Wscript.Echo "      ErrorCleared                  :" & SDC.ErrorCleared
      Wscript.Echo "      ErrorDescription              :" & SDC.ErrorDescription
      Wscript.Echo "      HealthState                   :" & SDC.HealthState
      Wscript.Echo "      IdentifyingDescriptions       :" & SDC.IdentifyingDescriptions
      Wscript.Echo "      InstallDate                   :" & SDC.InstallDate
      Wscript.Echo "      LastErrorCode                 :" & SDC.LastErrorCode
      Wscript.Echo "      LocationIndicator             :" & SDC.LocationIndicator
      Wscript.Echo "      MaxMemorySupported            :" & SDC.MaxMemorySupported
      Wscript.Echo "      MaxNumberControlled           :" & SDC.MaxNumberControlled
      Wscript.Echo "      MaxQuiesceTime                :" & SDC.MaxQuiesceTime
      Wscript.Echo "      Name                          :" & SDC.Name
      Wscript.Echo "      NumberOfVideoPages            :" & SDC.NumberOfVideoPages
      Wscript.Echo "      OperationalStatus             :" & SDC.OperationalStatus(0)
      Wscript.Echo "      OtherEnabledState             :" & SDC.OtherEnabledState
      Wscript.Echo "      OtherIdentifyingInfo          :" & SDC.OtherIdentifyingInfo
      Wscript.Echo "      OtherVideoMemoryType          :" & SDC.OtherVideoMemoryType
      Wscript.Echo "      PowerManagementCapabilities   :" & SDC.PowerManagementCapabilities
      Wscript.Echo "      PowerManagementSupported      :" & SDC.PowerManagementSupported
      Wscript.Echo "      PowerOnHours                  :" & SDC.PowerOnHours
      Wscript.Echo "      ProtocolDescription           :" & SDC.ProtocolDescription
      Wscript.Echo "      ProtocolSupported             :" & SDC.ProtocolSupported
      Wscript.Echo "      RequestedState                :" & SDC.RequestedState
      Wscript.Echo "      Status                        :" & SDC.Status
      Wscript.Echo "      StatusDescriptions            :" & SDC.StatusDescriptions(0)
      Wscript.Echo "      StatusInfo                    :" & SDC.StatusInfo
      Wscript.Echo "      SystemCreationClassName       :" & SDC.SystemCreationClassName
      Wscript.Echo "      SystemName                    :" & SDC.SystemName
      Wscript.Echo "      TimeOfLastReset               :" & SDC.TimeOfLastReset
      Wscript.Echo "      TimeOfLastStateChange         :" & SDC.TimeOfLastStateChange
      Wscript.Echo "      TimeOfLastStateChange         :" & SDC.TimeOfLastStateChange
      Wscript.Echo "      TotalPowerOnHours             :" & SDC.TotalPowerOnHours
      Wscript.Echo "      VideoMemoryType               :" & SDC.VideoMemoryType
      Wscript.Echo "      VideoProcessor                :" & SDC.VideoProcessor
      
   Case Else
   WScript.Echo targetVM & " ͎sł͂܂B" 
   End Select
End Function

'###
'### Function for decoding CIM_EnabledLogicalElement.EnableState
'### See http://msdn.microsoft.com/en-us/library/cc136818(v=VS.85).aspx
'###
function DecodeISEnableState(EnabledState)

    Select case EnabledState

        case 2
            stateStr = "Enabled(2)"
        case 3
            stateStr = "Disabled(3)"

    End Select

    DecodeISEnableState = stateStr

End Function

'###
'### Function for decoding Msvm_VirtualSystemGlobalSettingData.AutomaticStartupAction
'### See http://msdn.microsoft.com/en-us/library/cc136939(VS.85).aspx
'###
function DecodeAutomaticStartupAction(action)

    Select case action

        case 0
            actionStr = "Ȃ(0)"
        case 1
            actionStr = "T[rX~ƂɎsĂꍇ͎IɋN(1)"
        case 2
            actionStr = "ɂ̉z}VN(2)"

    End Select

    DecodeAutomaticStartupAction = actionStr

End Function

'###
'### Function for decoding Msvm_VirtualSystemGlobalSettingData.AutomaticShutdownAction
'### See http://msdn.microsoft.com/en-us/library/cc136939(VS.85).aspx
'###
function DecodeAutomaticShutdownAction(action)

    Select case action

        case 0
            actionStr = "z}V~(0)"
        case 1
            actionStr = "z}V̏Ԃۑ(1)"
        case 2
            actionStr = "QXg Iy[eBO VXeVbg_E(2)"

    End Select

    DecodeAutomaticShutdownAction = actionStr

End Function

'###
'### Function for decoding Msvm_ComputerSystem.EnableStatus
'### See http://msdn.microsoft.com/en-us/library/cc136818(v=vs.85).aspx
'###
Function DecodeEnableStatus(status)

    Dim StatusMsg 

    Select case status
        case 0
            StatusMsg = "Unknown(0)"
        case 2
            StatusMsg = "Running(2)"
        case 3
            StatusMsg = "Turned off(3)"
        case 32768
            StatusMsg = "Paused(32768)"
        case 32769
            StatusMsg = "Suspended(32769)"
        case 32770
            StatusMsg = "Starting(32770)"
        case 32771
            StatusMsg = "Snapshotting(32771)"
        case 32773
            StatusMsg = "Saving(32773)"
        case 32774
            StatusMsg = "Stopping(32774)"
        case 32776
            StatusMsg = "Pausing(32776)"
        case 32777
            StatusMsg = "Resuming(32777)"

    End Select

    DecodeEnableStatus = StatusMsg 

End Function


'###
'### Function for decoding CIM_ManagedSystemElement.HealthState
'### See http://msdn.microsoft.com/en-us/library/aa387898(v=vs.85).aspx
'###
Function DecodeHealthState(status)

    Dim StatusMsg 

    Select case status
        case 0
            StatusMsg = "Unknown(0)"
        case 5
            StatusMsg = "OK(5)"
        case 10
            StatusMsg = "Degraded/Warning(10)"
        case 15
            StatusMsg = "Minor failure(15)"
        case 20
            StatusMsg = "Major Failure(20)"
        case 25
            StatusMsg = "Critical failure(25)"
        case 30
            StatusMsg = "Non-recoverable error(30)"
    End Select

    DecodeHealthState = StatusMsg 

End Function